!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: killbill.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 MEMBER
 MAP
wndEnumWindow PROCEDURE(ULONG hWnd,ULONG lParam),BOOL,PASCAL ! callback  EnumWindows
 END

 INCLUDE('killbill.inc'),ONCE
 INCLUDE('CFCAPI.inc'),ONCE
KillBill.Construct        PROCEDURE
 CODE
 SELF.WndQueue &= NEW typeWndQueue
KillBill.Destruct         PROCEDURE
 CODE
 IF NOT SELF.WndQueue &= NULL
    DISPOSE(SELF.WndQueue)
 END
KillBill.EnumerateWindows PROCEDURE
 CODE
 FREE(SELF.WndQueue)
 IF NOT CFC_EnumWindows(ADDRESS(wndEnumWindow),ADDRESS(SELF))
 END
KillBill.FindAndTerminate_enkaScan PROCEDURE
 CODE
 SELF.EnumerateWindows()
 LOOP j# = 1 TO RECORDS(SELF.WndQueue)
    GET(SELF.WndQueue,j#)
    IF UPPER(SELF.WndQueue.Caption) = 'ENKASCAN'
       SELF.KillProcess(SELF.WndQueue.hWindow)
    END
 END
KillBill.StartProcess PROCEDURE(STRING inFileName,STRING inWorkDirectory)
loc:ApplicationName    CSTRING(256)
loc:CommandLine        CSTRING(256)
loc:CurrentDirectory   CSTRING(256)
ProcessAttributes      LIKE(CFC_SECURITY_ATTRIBUTES)
ThreadAttributes       LIKE(CFC_SECURITY_ATTRIBUTES)
loc:Environment        LONG
loc:StartupInfo        LIKE(CFC_STARTUPINFO)
loc:Reserved           LONG
loc:ProcessInformation LIKE(CFC_PROCESS_INFORMATION)
bInheritHandles        BOOL
 CODE
 loc:ApplicationName = CLIP(inFileName)
 loc:CommandLine = ''
 loc:Environment = 0
 loc:CurrentDirectory = CLIP(inWorkDirectory)

 ProcessAttributes.nLength = SIZE(CFC_SECURITY_ATTRIBUTES)
 ProcessAttributes.lpSecurityDescriptor = 0
 ProcessAttributes.bInheritHandle = FALSE

 ThreadAttributes.nLength = SIZE(CFC_SECURITY_ATTRIBUTES)
 ThreadAttributes.lpSecurityDescriptor = 0
 ThreadAttributes.bInheritHandle = FALSE

 bInheritHandles = False
 loc:Reserved = 0

 CLEAR(loc:StartupInfo)
 loc:StartupInfo.cb = SIZE(CFC_STARTUPINFO)
 loc:StartupInfo.dwFlags = CFC_STARTF_USESHOWWINDOW

 IF CFC_CreateProcess(loc:ApplicationName, |
                  loc:CommandLine,           |
                  0,        |
                  0,         |
                  0,          |
                  CFC_CREATE_NEW_PROCESS_GROUP + CFC_NORMAL_PRIORITY_CLASS, |
                  0,        |
                  loc:CurrentDirectory,   |
                  loc:StartupInfo,        |
                  loc:ProcessInformation)
  END
KillBill.KillProcess  PROCEDURE(ULONG hWnd)
loc:ExitCode    LONG
loc:ReturnValue ULONG
loc:dwProcessId ULONG
loc:hProcess    ULONG
 CODE
 loc:ExitCode=0
 err# = CFC_GetWindowThreadProcessId(hWnd,loc:dwProcessId)
 loc:hProcess = CFC_OpenProcess(CFC_PROCESS_QUERY_INFORMATION + CFC_PROCESS_TERMINATE,FALSE,loc:dwProcessId)
 IF loc:hProcess
    IF CFC_GetExitCodeProcess(loc:hProcess,loc:ExitCode)
       IF CFC_TerminateProcess(loc:hProcess, loc:ExitCode)
          clear(self.TRAYDATA)
          self.TRAYDATA.cbSize=size(kbNOTIFYICONDATA)
          self.TRAYDATA.hWnd=hWnd
          self.TRAYDATA.uID=100
          kbShell_NotifyIcon(kbNIM_DELETE, address(self.TRAYDATA))
          err# = CFC_CloseHandle(loc:hProcess)
       END
    END
 END
wndEnumWindow PROCEDURE(ULONG hWnd,ULONG lParam) ! callback  EnumWindows
loc:TitleName   CSTRING(256)
loc:dwProcessId ULONG
KB              &KillBill
 CODE
 KB &= (lParam)
 IF NOT CFC_GetWindowText(hWnd,ADDRESS(loc:TitleName),SIZE(loc:TitleName))
    loc:TitleName = 'Unknown'
 END
 err# = CFC_GetWindowThreadProcessId(hWnd, loc:dwProcessId)
 CLEAR(KB.WndQueue)
 KB.WndQueue.Caption = CLIP(loc:TitleName)
 KB.WndQueue.hWindow = hWnd
 KB.WndQueue.PID = loc:dwProcessId
 ADD(KB.WndQueue)
 RETURN TRUE


