
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Declaration File Contents
!!!!! File Name: CFCAPI.inc
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! *******************************************************************************************************
!  Windows API 
! *******************************************************************************************************
OMIT('_EndOfInclude_',_CFCAPIPresent_)
_CFCAPIPresent_ EQUATE(1)
!  
CFC_LOGFONT                        GROUP,TYPE
lfHeight                              LONG
lfWidth                               LONG
lfEscapement                          LONG
lfOrientation                         LONG
lfWeight                              LONG
lfItalic                              BYTE
lfUnderline                           BYTE
lfStrikeOut                           BYTE
lfCharSet                             BYTE
lfOutPrecision                        BYTE
lfClipPrecision                       BYTE
lfQuality                             BYTE
lfPitchAndFamily                      BYTE
lfFaceName                            CSTRING(32)
                                   END

CFC_POINT                          GROUP,TYPE
x                                     LONG
y                                     LONG
                                   END

CFC_RECT                           GROUP,TYPE
left                                  LONG
top                                   LONG
right                                 LONG
bottom                                LONG
                                   END

CFC_PRINTER_INFO_2                 GROUP,TYPE
pServerName                           LONG !    (  )
pPrinterName                          LONG
pShareName                            LONG
pPortName                             LONG
pDriverName                           LONG
pComment                              LONG
pLocation                             LONG
pDevMode                              LONG !    DEVMODE
pSepFile                              LONG !    (  )
pPrintProcessor                       LONG
pDatatype                             LONG
pParameters                           LONG
pSecurityDescriptor                   LONG !    SECURITY_DESCRIPTOR
Attributes                            LONG !  LONG (DWORD   )
Priority                              LONG
DefaultPriority                       LONG
StartTime                             LONG
UntilTime                             LONG
Status                                LONG
cJobs                                 LONG
AveragePPM                            LONG
                                   END

CFC_PRINTER_ENUM_DEFAULT           EQUATE(1)
CFC_PRINTER_ENUM_LOCAL             EQUATE(2)
CFC_PRINTER_ENUM_CONNECTIONS       EQUATE(4)
CFC_PRINTER_ENUM_FAVORITE          EQUATE(4)
CFC_PRINTER_ENUM_NAME              EQUATE(8)
CFC_PRINTER_ENUM_REMOTE            EQUATE(010h)
CFC_PRINTER_ENUM_SHARED            EQUATE(020h)
CFC_PRINTER_ENUM_NETWORK           EQUATE(040h)

CFC_DRAWITEMSTRUCT                GROUP,TYPE
CtlType                              ULONG
CtlID                                ULONG
itemID                               ULONG
itemAction                           ULONG
itemState                            ULONG
hwndItem                             ULONG
hDC                                  ULONG
rcItem                               LIKE(CFC_RECT)
itemData                             ULONG
                                  END

CFC_PAINTSTRUCT                   GROUP,TYPE
hdc                                  ULONG
fErase                               BOOL
rcPaint                              LIKE(CFC_RECT)
fRestore                             BOOL
fIncUpdate                           BOOL
rgbReserved                          BYTE,DIM(32)
                                  END


CFC_ICONINFO                      GROUP,TYPE
fIcon                                LONG
xHotspot                             LONG
yHotspot                             LONG
hbmMask                              LONG
hbmColor                             LONG
                                  END

CFC_BITMAP                        GROUP,TYPE
bmType                               LONG
bmWidth                              LONG
bmHeight                             LONG
bmWidthBytes                         LONG
bmPlanes                             SHORT
bmBitsPixel                          SHORT
bmBits                               LONG
                                  END

CFC_SCROLLINFO                    GROUP,TYPE
cbSize                               ULONG
fMask                                ULONG
nMin                                 ULONG
nMax                                 LONG
nPage                                ULONG
nPos                                 ULONG
nTrackPos                            LONG
                                  END

CFC_OSVERSIONINFO                 GROUP,TYPE
dwOSVersionInfoSize                  LONG
dwMajorVersion                       LONG
dwMinorVersion                       LONG
dwBuildNumber                        LONG
dwPlatformId                         LONG
szCSDVersion                         CSTRING(128)
                                  END

CFC_PRINTER_DEFAULTS              GROUP,TYPE
pDatatype                            LONG     !    ( )
pDevMode                             LONG     !   DEVMODE 
DesiredAccess                        LONG     !    
                                  END


CFC_MENUINFO                      GROUP,TYPE
cbSize                               LONG
fMask                                LONG
dwStyle                              LONG
cyMax                                LONG
hbrBack                              ULONG
dwContextHelpID                      LONG
dwMenuData                           ULONG
                                  END

CFC_MENUITEMINFO                  GROUP,TYPE
cbSize                               ULONG
fMask                                ULONG
fType                                ULONG
fState                               ULONG
wID                                  ULONG
hSubMenu                             ULONG
hbmpChecked                          ULONG
hbmpUnchecked                        ULONG
dwItemData                           ULONG
dwTypeData                           ULONG
cch                                  ULONG
hbmpItem                             ULONG
                                  END

CFC_REBARINFO                     GROUP,TYPE
cbSize                               ULONG
fMask                                ULONG
himl                                 ULONG
                                  END


CFC_REBARBANDINFO                 GROUP,TYPE
cbSize                               ULONG
fMask                                ULONG
fStyle                               ULONG
clrFore                              ULONG
clrBack                              ULONG
lpText                               ULONG
cch                                  LONG
iImage                               LONG
hwndChild                            ULONG
cxMinChild                           ULONG
cyMinChild                           ULONG
cx                                   ULONG
hbmBack                              ULONG
wID                                  ULONG
cyChild                              ULONG
cyMaxChild                           ULONG
cyIntegral                           ULONG
cxIdeal                              ULONG
lParam                               LONG
cxHeader                             ULONG
                                  END


CFC_INITCOMMONCONTROLSEX          GROUP,TYPE
dwSize                               LONG
dwICC                                LONG
                                  END

CFC_WINDOWPOS                     GROUP,TYPE
hwnd                                 ULONG
hwndInsertAfter                      ULONG
x                                    LONG
y                                    LONG
cx                                   LONG
cy                                   LONG
flags                                ULONG
                                  END

CFC_NCCALCSIZE_PARAMS             GROUP,TYPE
rgrc                                 LIKE(CFC_RECT),DIM(3)
lppos                                LONG
                                  END

CFC_NMHDR                         GROUP,TYPE
hwndFrom                             ULONG
idFrom                               ULONG
_code                                ULONG
                                  END


CFC_NMREBARCHILDSIZE              GROUP,TYPE
hdr                                  LIKE(CFC_NMHDR)
uBand                                ULONG
wID                                  ULONG
rcChild                              LIKE(CFC_RECT)
rcBand                               LIKE(CFC_RECT)
                                  END

CFC_TBBUTTON                      GROUP,TYPE
iBitmap                              LONG
idCommand                            LONG
fsState                              BYTE
fsStyle                              BYTE
bReserved                            BYTE,DIM(2)
dwData                               LONG
iString                              LONG
                                  END


CFC_TBADDBITMAP                   GROUP,TYPE
hInst                                ULONG
nID                                  ULONG
                                  END

CFC_SIZE                          GROUP,TYPE
cx                                   LONG
cy                                   LONG
                                  END

CFC_TBBUTTONINFO                  GROUP,TYPE
cbSize                               ULONG
dwMask                               LONG
idCommand                            LONG
iImage                               LONG
fsState                              BYTE
fsStyle                              BYTE
cx                                   SHORT
lParam                               LONG
pszText                              LONG
cchText                              LONG
                                  END

CFC_COLORSCHEME                   GROUP,TYPE
dwSize                               LONG
clrBtnHighlight                      ULONG
clrBtnShadow                         ULONG
                                  END

CFC_NMTTDISPINFO                  GROUP,TYPE
hdr                                  LIKE(CFC_NMHDR)
lpszText                             LONG
szText                               CSTRING(80)
hinst                                ULONG
uFlags                               ULONG
lParam                               LONG
                                  END


CFC_TOOLINFO                      GROUP,TYPE
cbSize                               ULONG
uFlags                               ULONG
hwnd                                 ULONG
uId                                  ULONG
rect                                 LIKE(CFC_RECT)
hinst                                ULONG
lpszText                             LONG
lParam                               LONG
                                  END


CFC_HITTESTINFO                   GROUP,TYPE
hwnd                                 ULONG
pt                                   LIKE(CFC_POINT)
ti                                   LIKE(CFC_TOOLINFO)
                                  END

CFC_MSG                           GROUP,TYPE
hwnd                                 LONG
_message                             ULONG
wParam                               ULONG
lParam                               LONG
_time                                LONG
pt                                   LIKE(CFC_POINT)
                                  END

CFC_CWPSTRUCT                     GROUP,TYPE
lParam                               LONG
wParam                               ULONG
_Msg                                 ULONG
hwnd                                 ULONG
                                  END


CFC_DllVersionInfo                GROUP,TYPE
cbSize                               LONG
dwMajorVersion                       LONG
dwMinorVersion                       LONG
dwBuildNumber                        LONG
dwPlatformID                         LONG
                                  END

CFC_TTGETTITLE                    GROUP,TYPE
dwSize                               LONG
uTitleBitmap                         ULONG
cch                                  ULONG
pszTitle                             LONG
                                  END


CFC_MEASUREITEMSTRUCT             GROUP,TYPE
CtlType                              ULONG
CtlID                                ULONG
ItemID                               ULONG
itemWidth                            ULONG
itemHeight                           ULONG
itemData                             ULONG
                                  END

CFC_SIZESTRUCT                    GROUP,TYPE
cx                                   LONG
cy                                   LONG
                                  END

CFC_NONCLIENTMETRICS              GROUP,TYPE
cbSize                               ULONG
iBorderWidth                         LONG
iScrollWidth                         LONG
iScrollHeight                        LONG
iCaptionWidth                        LONG
iCaptionHeight                       LONG
lfCaptionFont                        LIKE(CFC_LOGFONT)
iSmCaptionWidth                      LONG
iSmCaptionHeight                     LONG
lfSmCaptionFont                      LIKE(CFC_LOGFONT)
iMenuWidth                           LONG
iMenuHeight                          LONG
lfMenuFont                           LIKE(CFC_LOGFONT)
lfStatusFont                         LIKE(CFC_LOGFONT)
lfMessageFont                        LIKE(CFC_LOGFONT)
                                  END


CFC_TRIVERTEX                     GROUP,TYPE
x                                    LONG
y                                    LONG
Red                                  USHORT
Green                                USHORT
Blue                                 USHORT
Alpha                                USHORT
                                  END

CFC_GRADIENT_RECT                 GROUP,TYPE
UpperLeft                            ULONG
LowerRight                           ULONG
                                  END

CFC_BLENDFUNCTION                 GROUP,TYPE
BlendOp                              BYTE
BlendFlags                           BYTE
SourceConstantAlpha                  BYTE
AlphaFormat                          BYTE
                                  END

CFC_MENUBARINFO                   GROUP,TYPE
cbSize                               LONG
rcBar                                LIKE(CFC_RECT)
hMenu                                ULONG
hwndMenu                             ULONG
fBarFocused                          SHORT
fFocused                             SHORT
                                  END

CFC_NMTOOLBAR                     GROUP,TYPE
NMHDR                                LIKE(CFC_NMHDR)
iItem                                LONG
tbButton                             LIKE(CFC_TBBUTTON)
cchText                              LONG
pszText                              LONG
rcButton                             LIKE(CFC_RECT)
                                  END

CFC_NMCUSTOMDRAW                  GROUP,TYPE
hdr                                  LIKE(CFC_NMHDR)
dwDrawStage                          LONG
hdc                                  ULONG
rc                                   LIKE(CFC_RECT)
dwItemSpec                           LONG
uItemState                           ULONG
lItemlParam                          LONG
                                  END

CFC_NMTBCUSTOMDRAW                GROUP,TYPE
nmcd                                 LIKE(CFC_NMCUSTOMDRAW)
hbrMonoDither                        ULONG
hbrLines                             ULONG
hpenLines                            ULONG
clrText                              LONG
clrMark                              LONG
clrTextHighlight                     LONG
clrBtnFace                           LONG
clrBtnHighlight                      LONG
clrHighlightHotTrack                 LONG
rcText                               LIKE(CFC_RECT)
nStringBkMode                        LONG
nHLStringBkMode                      LONG
iListGap                             LONG
                                  END

CFC_NOTIFYICONDATA                GROUP,TYPE ! < 5.0
cbSize                               LONG
hWnd                                 ULONG
uID                                  ULONG
uFlags                               ULONG
uCallbackMessage                     ULONG
hIcon                                ULONG
szTip                                CSTRING(64)
                                  END


CFC_NOTIFYICONDATA_NT             GROUP,TYPE ! 5.0
cbSize                               LONG
hWnd                                 ULONG
uID                                  ULONG
uFlags                               ULONG
uCallbackMessage                     ULONG
hIcon                                ULONG
szTip                                CSTRING(128)
dwState                              LONG
dwStateMask                          LONG
szInfo                               CSTRING(256)
uTimeout                             ULONG
uVersion                             ULONG,OVER(uTimeout) ! Used with Shell_NotifyIcon flag NIM_SETVERSION.
szInfoTitle                          CSTRING(64)
dwInfoFlags                          LONG
                                  END


CFC_NOTIFYICONDATA_XP             GROUP,TYPE ! 6.0
cbSize                               LONG
hWnd                                 ULONG
uID                                  ULONG
uFlags                               ULONG
uCallbackMessage                     ULONG
hIcon                                ULONG
szTip                                CSTRING(128)
dwState                              LONG
dwStateMask                          LONG
szInfo                               CSTRING(256)
uTimeout                             ULONG
uVersion                             ULONG,OVER(uTimeout) ! Used with Shell_NotifyIcon flag NIM_SETVERSION.
szInfoTitle                          CSTRING(64)
dwInfoFlags                          LONG
guidItem                             STRING(16)
                                  END


CFC_NOTIFYICONDATA_VISTA          GROUP,TYPE ! 6.0.6
cbSize                               LONG
hWnd                                 ULONG
uID                                  ULONG
uFlags                               ULONG
uCallbackMessage                     ULONG
hIcon                                ULONG
szTip                                CSTRING(128)
dwState                              LONG
dwStateMask                          LONG
szInfo                               CSTRING(256)
uTimeout                             ULONG
uVersion                             ULONG,OVER(uTimeout) ! Used with Shell_NotifyIcon flag NIM_SETVERSION.
szInfoTitle                          CSTRING(64)
dwInfoFlags                          LONG
guidItem                             STRING(16)
hBalloonIcon                         ULONG
                                  END

CFC_SECURITY_ATTRIBUTES           GROUP,TYPE
nLength                              ULONG
lpSecurityDescriptor                 ULONG
bInheritHandle                       BOOL
                                  END

CFC_STARTUPINFO                   GROUP,TYPE
cb                                   ULONG
lpReserved                           LONG
lpDesktop                            LONG
lpTitle                              LONG
dwX                                  ULONG
dwY                                  ULONG
dwXSize                              ULONG
dwYSize                              ULONG
dwXCountChars                        ULONG
dwYCountChars                        ULONG
dwFillAttribute                      ULONG
dwFlags                              ULONG
wShowWindow                          LONG
cbReserved2                          LONG
lpReserved2                          LONG
hStdInput                            ULONG
hStdOutput                           ULONG
hStdError                            ULONG
                                  END

CFC_PROCESS_INFORMATION           GROUP,TYPE
hProcess                             ULONG
hThread                              ULONG
dwProcessId                          ULONG
dwThreadId                           ULONG
                                  END

CFC_FILETIME                      GROUP,TYPE
dwLowDateTime                        LONG
dwHighDateTime                       LONG
                                  END

CFC_SYSTEMTIME                    GROUP,TYPE
wYear                                SHORT
wMonth                               SHORT
wDayOfWeek                           SHORT
wDay                                 SHORT
wHour                                SHORT
wMinute                              SHORT
wSecond                              SHORT
wMilliseconds                        SHORT
                                  END


CFC_COPYDATASTRUCT                GROUP,TYPE
dwData                               ULONG
cbData                               LONG
lpData                               LONG
                                  END


CFC_OPENFILENAME                  GROUP,TYPE
lStructSize                          LONG
hwndOwner                            ULONG
hInstance                            ULONG
lpstrFilter                          LONG
lpstrCustomFilter                    LONG
nMaxCustFilter                       LONG
nFilterIndex                         LONG
lpstrFile                            LONG
nMaxFile                             LONG
lpstrFileTitle                       LONG
nMaxFileTitle                        LONG
lpstrInitialDir                      LONG
lpstrTitle                           LONG
Flags                                LONG
nFileOffset                          SHORT
nFileExtension                       SHORT
lpstrDefExt                          LONG
lCustData                            LONG
lpfnHook                             LONG
lpTemplateName                       LONG
pvReserved                           LONG
dwReserved                           LONG
FlagsEx                              LONG
                                  END
! 

CFC_FW_DONTCARE                   EQUATE(0)
CFC_FW_THIN                       EQUATE(100)
CFC_FW_EXTRALIGHT                 EQUATE(200)
CFC_FW_ULTRALIGHT                 EQUATE(200)
CFC_FW_LIGHT                      EQUATE(300)
CFC_FW_NORMAL                     EQUATE(400)
CFC_FW_REGULAR                    EQUATE(400)
CFC_FW_MEDIUM                     EQUATE(500)
CFC_FW_SEMIBOLD                   EQUATE(600)
CFC_FW_DEMIBOLD                   EQUATE(600)
CFC_FW_BOLD                       EQUATE(700)
CFC_FW_EXTRABOLD                  EQUATE(800)
CFC_FW_ULTRABOLD                  EQUATE(800)
CFC_FW_HEAVY                      EQUATE(900)
CFC_FW_BLACK                      EQUATE(900)
CFC_ANSI_CHARSET                  EQUATE(0)
CFC_DEFAULT_CHARSET               EQUATE(1)
CFC_SYMBOL_CHARSET                EQUATE(2)
CFC_SHIFTJIS_CHARSET              EQUATE(128)
CFC_HANGEUL_CHARSET               EQUATE(129)
CFC_GB2312_CHARSET                EQUATE(134)
CFC_CHINESEBIG5_CHARSET           EQUATE(136)
CFC_OEM_CHARSET                   EQUATE(255)
CFC_OUT_DEFAULT_PRECIS            EQUATE(0)
CFC_CLIP_DEFAULT_PRECIS           EQUATE(0)
CFC_DEFAULT_QUALITY               EQUATE(0)
CFC_DRAFT_QUALITY                 EQUATE(1)
CFC_PROOF_QUALITY                 EQUATE(2)
CFC_DEFAULT_PITCH                 EQUATE(0)

CFC_TRANSPARENT                   EQUATE(1)
CFC_OPAQUE                        EQUATE(2)

CFC_SRCCOPY                       EQUATE(00CC0020H)

CFC_COLOR_SCROLLBAR               EQUATE(0)
CFC_COLOR_BACKGROUND              EQUATE(1)
CFC_COLOR_ACTIVECAPTION           EQUATE(2)
CFC_COLOR_INACTIVECAPTION         EQUATE(3)
CFC_COLOR_MENU                    EQUATE(4)
CFC_COLOR_WINDOW                  EQUATE(5)
CFC_COLOR_WINDOWFRAME             EQUATE(6)
CFC_COLOR_MENUTEXT                EQUATE(7)
CFC_COLOR_WINDOWTEXT              EQUATE(8)
CFC_COLOR_CAPTIONTEXT             EQUATE(9)
CFC_COLOR_ACTIVEBORDER            EQUATE(10)
CFC_COLOR_INACTIVEBORDER          EQUATE(11)
CFC_COLOR_APPWORKSPACE            EQUATE(12)
CFC_COLOR_HIGHLIGHT               EQUATE(13)
CFC_COLOR_HIGHLIGHTTEXT           EQUATE(14)
CFC_COLOR_BTNFACE                 EQUATE(15)
CFC_COLOR_BTNSHADOW               EQUATE(16)
CFC_COLOR_GRAYTEXT                EQUATE(17)
CFC_COLOR_BTNTEXT                 EQUATE(18)
CFC_COLOR_INACTIVECAPTIONTEXT     EQUATE(19)
CFC_COLOR_BTNHIGHLIGHT            EQUATE(20)
CFC_COLOR_3DDKSHADOW              EQUATE(21)
CFC_COLOR_3DLIGHT                 EQUATE(22)
CFC_COLOR_INFOTEXT                EQUATE(23)
CFC_COLOR_INFOBK                  EQUATE(24)
CFC_COLOR_HOTLIGHT                EQUATE(26)
CFC_COLOR_GRADIENTACTIVECAPTION   EQUATE(27)
CFC_COLOR_GRADIENTINACTIVECAPTION EQUATE(28)
CFC_COLOR_MENUBAR                 EQUATE(30)

CFC_DT_TOP                        EQUATE(0)
CFC_DT_LEFT                       EQUATE(0)
CFC_DT_CENTER                     EQUATE(1)
CFC_DT_RIGHT                      EQUATE(2)
CFC_DT_VCENTER                    EQUATE(4)
CFC_DT_BOTTOM                     EQUATE(8)
CFC_DT_WORDBREAK                  EQUATE(010h)
CFC_DT_SINGLELINE                 EQUATE(020h)
CFC_DT_EXPANDTABS                 EQUATE(040h)
CFC_DT_TABSTOP                    EQUATE(080h)
CFC_DT_NOCLIP                     EQUATE(0100h)
CFC_DT_EXTERNALLEADING            EQUATE(0200h)
CFC_DT_CALCRECT                   EQUATE(0400h)
CFC_DT_NOPREFIX                   EQUATE(0800h)
CFC_DT_INTERNAL                   EQUATE(01000h)
CFC_DT_EDITCONTROL                EQUATE(02000h)
CFC_DT_PATH_ELLIPSIS              EQUATE(04000h)
CFC_DT_END_ELLIPSIS               EQUATE(08000h)
CFC_DT_MODIFYSTRING               EQUATE(010000h)
CFC_DT_RTLREADING                 EQUATE(020000h)
CFC_DT_WORD_ELLIPSIS              EQUATE(040000h)

CFC_TA_NOUPDATECP                 EQUATE(0)
CFC_TA_UPDATECP                   EQUATE(1)
CFC_TA_LEFT                       EQUATE(0)
CFC_TA_RIGHT                      EQUATE(2)
CFC_TA_CENTER                     EQUATE(6)
CFC_TA_TOP                        EQUATE(0)
CFC_TA_BOTTOM                     EQUATE(8)
CFC_TA_BASELINE                   EQUATE(24)
CFC_TA_RTLREADING                 EQUATE(256)

CFC_SW_HIDE                       EQUATE(0)
CFC_SW_SHOWNORMAL                 EQUATE(1)
CFC_SW_NORMAL                     EQUATE(1)
CFC_SW_SHOWMINIMIZED              EQUATE(2)
CFC_SW_SHOWMAXIMIZED              EQUATE(3)
CFC_SW_MAXIMIZE                   EQUATE(3)
CFC_SW_SHOWNOACTIVATE             EQUATE(4)
CFC_SW_SHOW                       EQUATE(5)
CFC_SW_MINIMIZE                   EQUATE(6)
CFC_SW_SHOWMINNOACTIVE            EQUATE(7)
CFC_SW_SHOWNA                     EQUATE(8)
CFC_SW_RESTORE                    EQUATE(9)
CFC_SW_SHOWDEFAULT                EQUATE(10)
CFC_SW_MAX                        EQUATE(10)


CFC_ERROR_INSUFFICIENT_BUFFER     EQUATE(122)

! Button Control Styles ( )
CFC_BS_PUSHBUTTON                 EQUATE(0)
CFC_BS_DEFPUSHBUTTON              EQUATE(1)
CFC_BS_CHECKBOX                   EQUATE(2)
CFC_BS_AUTOCHECKBOX               EQUATE(3)
CFC_BS_RADIOBUTTON                EQUATE(4)
CFC_BS_3STATE                     EQUATE(5)
CFC_BS_AUTO3STATE                 EQUATE(6)
CFC_BS_GROUPBOX                   EQUATE(7)
CFC_BS_USERBUTTON                 EQUATE(8)
CFC_BS_AUTORADIOBUTTON            EQUATE(9)
CFC_BS_OWNERDRAW                  EQUATE(0Bh)
CFC_BS_LEFTTEXT                   EQUATE(020h)
CFC_BS_TEXT                       EQUATE(0)
CFC_BS_ICON                       EQUATE(040h)
CFC_BS_BITMAP                     EQUATE(080h)
CFC_BS_LEFT                       EQUATE(0100h)
CFC_BS_RIGHT                      EQUATE(0200h)
CFC_BS_CENTER                     EQUATE(0300h)
CFC_BS_TOP                        EQUATE(0400h)
CFC_BS_BOTTOM                     EQUATE(0800h)
CFC_BS_VCENTER                    EQUATE(0C00h)
CFC_BS_PUSHLIKE                   EQUATE(01000h)
CFC_BS_MULTILINE                  EQUATE(02000h)
CFC_BS_NOTIFY                     EQUATE(04000h)
CFC_BS_FLAT                       EQUATE(08000h)
CFC_BS_RIGHTBUTTON                EQUATE(CFC_BS_LEFTTEXT)

! User Button Notification Codes
CFC_BN_CLICKED                    EQUATE(0)
CFC_BN_PAINT                      EQUATE(1)
CFC_BN_HILITE                     EQUATE(2)
CFC_BN_UNHILITE                   EQUATE(3)
CFC_BN_DISABLE                    EQUATE(4)
CFC_BN_DOUBLECLICKED              EQUATE(5)
CFC_BN_PUSHED                     EQUATE(CFC_BN_HILITE)
CFC_BN_UNPUSHED                   EQUATE(CFC_BN_UNHILITE)
CFC_BN_DBLCLK                     EQUATE(CFC_BN_DOUBLECLICKED)
CFC_BN_SETFOCUS                   EQUATE(6)
CFC_BN_KILLFOCUS                  EQUATE(7)

! Button Control Messages
CFC_BM_GETCHECK                   EQUATE(0F0h)
CFC_BM_SETCHECK                   EQUATE(0F1h)
CFC_BM_GETSTATE                   EQUATE(0F2h)
CFC_BM_SETSTATE                   EQUATE(0F3h)
CFC_BM_SETSTYLE                   EQUATE(0F4h)
CFC_BM_CLICK                      EQUATE(0F5h)
CFC_BM_GETIMAGE                   EQUATE(0F6h)
CFC_BM_SETIMAGE                   EQUATE(0F7h)
CFC_BST_UNCHECKED                 EQUATE(0)
CFC_BST_CHECKED                   EQUATE(1)
CFC_BST_INDETERMINATE             EQUATE(2)
CFC_BST_PUSHED                    EQUATE(4)
CFC_BST_FOCUS                     EQUATE(8)

! Window field offsets for GetWindowLong()
CFC_GWL_WNDPROC                   EQUATE(-4)
CFC_GWL_HINSTANCE                 EQUATE(-6)
CFC_GWL_HWNDPARENT                EQUATE(-8)
CFC_GWL_STYLE                     EQUATE(-16)
CFC_GWL_EXSTYLE                   EQUATE(-20)
CFC_GWL_USERDATA                  EQUATE(-21)
CFC_GWL_ID                        EQUATE(-12)

CFC_ODS_SELECTED                  EQUATE(1)
CFC_ODS_GRAYED                    EQUATE(2)
CFC_ODS_DISABLED                  EQUATE(4)
CFC_ODS_CHECKED                   EQUATE(8)
CFC_ODS_FOCUS                     EQUATE(010h)
CFC_ODS_DEFAULT                   EQUATE(020h)
CFC_ODS_COMBOBOXEDIT              EQUATE(01000h)
CFC_ODS_HOTLIGHT                  EQUATE(040h)
CFC_ODS_INACTIVE                  EQUATE(080h)

CFC_IMAGE_BITMAP                  EQUATE(0)
CFC_IMAGE_ICON                    EQUATE(1)
CFC_IMAGE_CURSOR                  EQUATE(2)
CFC_IMAGE_ENHMETAFILE             EQUATE(3)

CFC_LR_DEFAULTCOLOR               EQUATE(0)
CFC_LR_MONOCHROME                 EQUATE(1)
CFC_LR_COLOR                      EQUATE(2)
CFC_LR_COPYRETURNORG              EQUATE(4)
CFC_LR_COPYDELETEORG              EQUATE(8)
CFC_LR_LOADFROMFILE               EQUATE(010h)
CFC_LR_LOADTRANSPARENT            EQUATE(020h)
CFC_LR_DEFAULTSIZE                EQUATE(040h)
CFC_LR_LOADMAP3DCOLORS            EQUATE(01000h)
CFC_LR_CREATEDIBSECTION           EQUATE(02000h)
CFC_LR_COPYFROMRESOURCE           EQUATE(04000h)
CFC_LR_SHARED                     EQUATE(08000h)

CFC_DI_MASK                       EQUATE(1)
CFC_DI_IMAGE                      EQUATE(2)
CFC_DI_NORMAL                     EQUATE(3)
CFC_DI_COMPAT                     EQUATE(4)
CFC_DI_DEFAULTSIZE                EQUATE(8)

CFC_DST_COMPLEX                   EQUATE(0)
CFC_DST_TEXT                      EQUATE(1)
CFC_DST_PREFIXTEXT                EQUATE(2)
CFC_DST_ICON                      EQUATE(3)
CFC_DST_BITMAP                    EQUATE(4)

CFC_DSS_NORMAL                    EQUATE(0)
CFC_DSS_UNION                     EQUATE(010h)
CFC_DSS_DISABLED                  EQUATE(020h)
CFC_DSS_MONO                      EQUATE(080h)
CFC_DSS_RIGHT                     EQUATE(08000h)

CFC_DELETE                        EQUATE(010000h)
CFC_READ_CONTROL                  EQUATE(020000h)
CFC_WRITE_DAC                     EQUATE(040000h)
CFC_WRITE_OWNER                   EQUATE(080000h)
CFC_SYNCHRONIZE                   EQUATE(0100000h)

CFC_STANDARD_RIGHTS_REQUIRED      EQUATE(0F0000h)
CFC_STANDARD_RIGHTS_READ          EQUATE(CFC_READ_CONTROL)
CFC_STANDARD_RIGHTS_WRITE         EQUATE(CFC_READ_CONTROL)
CFC_STANDARD_RIGHTS_EXECUTE       EQUATE(CFC_READ_CONTROL)
CFC_STANDARD_RIGHTS_ALL           EQUATE(01F0000h)
CFC_SPECIFIC_RIGHTS_ALL           EQUATE(0FFFFh)

CFC_FILE_READ_DATA                EQUATE(1)
CFC_FILE_LIST_DIRECTORY           EQUATE(1)
CFC_FILE_WRITE_DATA               EQUATE(2)
CFC_FILE_ADD_FILE                 EQUATE(2)
CFC_FILE_APPEND_DATA              EQUATE(4)
CFC_FILE_ADD_SUBDIRECTORY         EQUATE(4)
CFC_FILE_CREATE_PIPE_INSTANCE     EQUATE(4)
CFC_FILE_READ_EA                  EQUATE(8)
CFC_FILE_READ_PROPERTIES          EQUATE(CFC_FILE_READ_EA)
CFC_FILE_WRITE_EA                 EQUATE(010h)
CFC_FILE_WRITE_PROPERTIES         EQUATE(CFC_FILE_WRITE_EA)
CFC_FILE_EXECUTE                  EQUATE(020h)
CFC_FILE_TRAVERSE                 EQUATE(020h)
CFC_FILE_DELETE_CHILD             EQUATE(040h)
CFC_FILE_READ_ATTRIBUTES          EQUATE(080h)
CFC_FILE_WRITE_ATTRIBUTES         EQUATE(0100h)
CFC_FILE_ALL_ACCESS               EQUATE(CFC_STANDARD_RIGHTS_REQUIRED + CFC_SYNCHRONIZE + 01FFh)
CFC_FILE_GENERIC_READ             EQUATE(CFC_STANDARD_RIGHTS_READ + |
                                         CFC_FILE_READ_DATA + |
                                         CFC_FILE_READ_ATTRIBUTES + |
                                         CFC_FILE_READ_EA + |
                                         CFC_SYNCHRONIZE)
CFC_FILE_GENERIC_WRITE            EQUATE(CFC_STANDARD_RIGHTS_WRITE + |
                                         CFC_FILE_WRITE_DATA + |
                                         CFC_FILE_WRITE_ATTRIBUTES + |
                                         CFC_FILE_WRITE_EA + |
                                         CFC_FILE_APPEND_DATA + |
                                         CFC_SYNCHRONIZE)
CFC_FILE_GENERIC_EXECUTE          EQUATE(CFC_STANDARD_RIGHTS_EXECUTE + |
                                         CFC_FILE_READ_ATTRIBUTES + |
                                         CFC_FILE_EXECUTE + |
                                         CFC_SYNCHRONIZE)

CFC_FILE_SHARE_READ               EQUATE(1)
CFC_FILE_SHARE_WRITE              EQUATE(2)
CFC_FILE_SHARE_DELETE             EQUATE(4)
CFC_FILE_ATTRIBUTE_READONLY       EQUATE(1)
CFC_FILE_ATTRIBUTE_HIDDEN         EQUATE(2)
CFC_FILE_ATTRIBUTE_SYSTEM         EQUATE(4)
CFC_FILE_ATTRIBUTE_DIRECTORY      EQUATE(010h)
CFC_FILE_ATTRIBUTE_ARCHIVE        EQUATE(020h)
CFC_FILE_ATTRIBUTE_NORMAL         EQUATE(080h)
CFC_FILE_ATTRIBUTE_TEMPORARY      EQUATE(0100h)
CFC_FILE_ATTRIBUTE_COMPRESSED     EQUATE(0800h)
CFC_FILE_NOTIFY_CHANGE_FILE_NAME  EQUATE(1)
CFC_FILE_NOTIFY_CHANGE_DIR_NAME   EQUATE(2)
CFC_FILE_NOTIFY_CHANGE_ATTRIBUTES EQUATE(4)
CFC_FILE_NOTIFY_CHANGE_SIZE       EQUATE(8)
CFC_FILE_NOTIFY_CHANGE_LAST_WRITE EQUATE(010h)
CFC_FILE_NOTIFY_CHANGE_SECURITY   EQUATE(0100h)

CFC_CREATE_NEW                    EQUATE(1)
CFC_CREATE_ALWAYS                 EQUATE(2)
CFC_OPEN_EXISTING                 EQUATE(3)
CFC_OPEN_ALWAYS                   EQUATE(4)
CFC_TRUNCATE_EXISTING             EQUATE(5)

CFC_GENERIC_READ                  EQUATE(080000000h)
CFC_GENERIC_WRITE                 EQUATE(040000000h)
CFC_GENERIC_EXECUTE               EQUATE(020000000h)
CFC_GENERIC_ALL                   EQUATE(010000000h)

CFC_INVALID_HANDLE_VALUE          EQUATE(4294967295)

CFC_FILE_BEGIN                    EQUATE(0)
CFC_FILE_CURRENT                  EQUATE(1)
CFC_FILE_END                      EQUATE(2)

! Window Styles
CFC_WS_OVERLAPPED                 EQUATE(0)
CFC_WS_POPUP                      EQUATE(080000000h)
CFC_WS_CHILD                      EQUATE(040000000h)
CFC_WS_MINIMIZE                   EQUATE(020000000h)
CFC_WS_VISIBLE                    EQUATE(010000000h)
CFC_WS_DISABLED                   EQUATE(08000000h)
CFC_WS_CLIPSIBLINGS               EQUATE(04000000h)
CFC_WS_CLIPCHILDREN               EQUATE(02000000h)
CFC_WS_MAXIMIZE                   EQUATE(01000000h)
CFC_WS_CAPTION                    EQUATE(00C00000h)
CFC_WS_BORDER                     EQUATE(00800000h)
CFC_WS_DLGFRAME                   EQUATE(00400000h)
CFC_WS_VSCROLL                    EQUATE(00200000h)
CFC_WS_HSCROLL                    EQUATE(00100000h)
CFC_WS_SYSMENU                    EQUATE(00080000h)
CFC_WS_THICKFRAME                 EQUATE(00040000h)
CFC_WS_GROUP                      EQUATE(00020000h)
CFC_WS_TABSTOP                    EQUATE(00010000h)
CFC_WS_MINIMIZEBOX                EQUATE(020000h)
CFC_WS_MAXIMIZEBOX                EQUATE(010000h)

! Common Window Styles
CFC_WS_OVERLAPPEDWINDOW           EQUATE(CFC_WS_OVERLAPPED + |
                                         CFC_WS_CAPTION + |
                                         CFC_WS_SYSMENU + |
                                         CFC_WS_THICKFRAME + |
                                         CFC_WS_MINIMIZEBOX + |
                                         CFC_WS_MAXIMIZEBOX)

CFC_WS_POPUPWINDOW                EQUATE(CFC_WS_POPUP + |
                                         CFC_WS_BORDER + |
                                         CFC_WS_SYSMENU)

CFC_WS_CHILDWINDOW                EQUATE(CFC_WS_CHILD)

CFC_WS_TILED                      EQUATE(CFC_WS_OVERLAPPED)
CFC_WS_ICONIC                     EQUATE(CFC_WS_MINIMIZE)
CFC_WS_SIZEBOX                    EQUATE(CFC_WS_THICKFRAME)
CFC_WS_TILEDWINDOW                EQUATE(CFC_WS_OVERLAPPEDWINDOW)

CFC_SIF_RANGE                     EQUATE(1)
CFC_SIF_PAGE                      EQUATE(2)
CFC_SIF_POS                       EQUATE(4)
CFC_SIF_DISABLENOSCROLL           EQUATE(8)
CFC_SIF_TRACKPOS                  EQUATE(010h)
CFC_SIF_ALL                       EQUATE(CFC_SIF_RANGE + CFC_SIF_PAGE + CFC_SIF_POS + CFC_SIF_TRACKPOS)

! Scroll Bar Constants
CFC_SB_HORZ                       EQUATE(0)
CFC_SB_VERT                       EQUATE(1)
CFC_SB_CTL                        EQUATE(2)
CFC_SB_BOTH                       EQUATE(3)


! GetSystemMetrics() codes
CFC_SM_CXSCREEN                   EQUATE(0)
CFC_SM_CYSCREEN                   EQUATE(1)
CFC_SM_CXVSCROLL                  EQUATE(2)
CFC_SM_CYHSCROLL                  EQUATE(3)
CFC_SM_CYCAPTION                  EQUATE(4)
CFC_SM_CXBORDER                   EQUATE(5)
CFC_SM_CYBORDER                   EQUATE(6)
CFC_SM_CXDLGFRAME                 EQUATE(7)
CFC_SM_CYDLGFRAME                 EQUATE(8)
CFC_SM_CYVTHUMB                   EQUATE(9)
CFC_SM_CXHTHUMB                   EQUATE(10)
CFC_SM_CXICON                     EQUATE(11)
CFC_SM_CYICON                     EQUATE(12)
CFC_SM_CXCURSOR                   EQUATE(13)
CFC_SM_CYCURSOR                   EQUATE(14)
CFC_SM_CYMENU                     EQUATE(15)
CFC_SM_CXFULLSCREEN               EQUATE(16)
CFC_SM_CYFULLSCREEN               EQUATE(17)
CFC_SM_CYKANJIWINDOW              EQUATE(18)
CFC_SM_MOUSEPRESENT               EQUATE(19)
CFC_SM_CYVSCROLL                  EQUATE(20)
CFC_SM_CXHSCROLL                  EQUATE(21)
CFC_SM_DEBUG                      EQUATE(22)
CFC_SM_SWAPBUTTON                 EQUATE(23)
CFC_SM_RESERVED1                  EQUATE(24)
CFC_SM_RESERVED2                  EQUATE(25)
CFC_SM_RESERVED3                  EQUATE(26)
CFC_SM_RESERVED4                  EQUATE(27)
CFC_SM_CXMIN                      EQUATE(28)
CFC_SM_CYMIN                      EQUATE(29)
CFC_SM_CXSIZE                     EQUATE(30)
CFC_SM_CYSIZE                     EQUATE(31)
CFC_SM_CXFRAME                    EQUATE(32)
CFC_SM_CYFRAME                    EQUATE(33)
CFC_SM_CXMINTRACK                 EQUATE(34)
CFC_SM_CYMINTRACK                 EQUATE(35)
CFC_SM_CXDOUBLECLK                EQUATE(36)
CFC_SM_CYDOUBLECLK                EQUATE(37)
CFC_SM_CXICONSPACING              EQUATE(38)
CFC_SM_CYICONSPACING              EQUATE(39)
CFC_SM_MENUDROPALIGNMENT          EQUATE(40)
CFC_SM_PENWINDOWS                 EQUATE(41)
CFC_SM_DBCSENABLED                EQUATE(42)
CFC_SM_CMOUSEBUTTONS              EQUATE(43)
CFC_SM_CXFIXEDFRAME               EQUATE(CFC_SM_CXDLGFRAME)
CFC_SM_CYFIXEDFRAME               EQUATE(CFC_SM_CYDLGFRAME)
CFC_SM_CXSIZEFRAME                EQUATE(CFC_SM_CXFRAME)
CFC_SM_CYSIZEFRAME                EQUATE(CFC_SM_CYFRAME)
CFC_SM_SECURE                     EQUATE(44)
CFC_SM_CXEDGE                     EQUATE(45)
CFC_SM_CYEDGE                     EQUATE(46)
CFC_SM_CXMINSPACING               EQUATE(47)
CFC_SM_CYMINSPACING               EQUATE(48)
CFC_SM_CXSMICON                   EQUATE(49)
CFC_SM_CYSMICON                   EQUATE(50)
CFC_SM_CYSMCAPTION                EQUATE(51)
CFC_SM_CXSMSIZE                   EQUATE(52)
CFC_SM_CYSMSIZE                   EQUATE(53)
CFC_SM_CXMENUSIZE                 EQUATE(54)
CFC_SM_CYMENUSIZE                 EQUATE(55)
CFC_SM_ARRANGE                    EQUATE(56)
CFC_SM_CXMINIMIZED                EQUATE(57)
CFC_SM_CYMINIMIZED                EQUATE(58)
CFC_SM_CXMAXTRACK                 EQUATE(59)
CFC_SM_CYMAXTRACK                 EQUATE(60)
CFC_SM_CXMAXIMIZED                EQUATE(61)
CFC_SM_CYMAXIMIZED                EQUATE(62)
CFC_SM_NETWORK                    EQUATE(63)
CFC_SM_CLEANBOOT                  EQUATE(67)
CFC_SM_CXDRAG                     EQUATE(68)
CFC_SM_CYDRAG                     EQUATE(69)
CFC_SM_SHOWSOUNDS                 EQUATE(70)
CFC_SM_CXMENUCHECK                EQUATE(71)
CFC_SM_CYMENUCHECK                EQUATE(72)
CFC_SM_SLOWMACHINE                EQUATE(73)
CFC_SM_MIDEASTENABLED             EQUATE(74)
CFC_SM_CMETRICS                   EQUATE(75)

CFC_MAX_COMPUTERNAME_LENGTH       EQUATE(15)

CFC_PRINTER_ACCESS_ADMINISTER     EQUATE(4)
CFC_PRINTER_ACCESS_USE            EQUATE(8)
CFC_PRINTER_ALL_ACCESS            EQUATE(CFC_STANDARD_RIGHTS_REQUIRED + |
                                         CFC_PRINTER_ACCESS_ADMINISTER + |
                                         CFC_PRINTER_ACCESS_USE)
CFC_PRINTACTION_PROPERTIES        EQUATE(1)
CFC_PRINTACTION_DOCUMENTDEFAULTS  EQUATE(6)

CFC_VER_PLATFORM_WIN32s           EQUATE(0)
CFC_VER_PLATFORM_WIN32_WINDOWS    EQUATE(1)
CFC_VER_PLATFORM_WIN32_NT         EQUATE(2)


! menus
CFC_MF_INSERT                     EQUATE(0)
CFC_MF_CHANGE                     EQUATE(080h)
CFC_MF_APPEND                     EQUATE(0100h)
CFC_MF_DELETE                     EQUATE(0200h)
CFC_MF_REMOVE                     EQUATE(01000h)
CFC_MF_BYCOMMAND                  EQUATE(0)
CFC_MF_BYPOSITION                 EQUATE(0400h)
CFC_MF_SEPARATOR                  EQUATE(0800h)
CFC_MF_ENABLED                    EQUATE(0)
CFC_MF_GRAYED                     EQUATE(01h)
CFC_MF_DISABLED                   EQUATE(02h)
CFC_MF_UNCHECKED                  EQUATE(0)
CFC_MF_CHECKED                    EQUATE(08h)
CFC_MF_USECHECKBITMAPS            EQUATE(0200h)
CFC_MF_STRING                     EQUATE(0)
CFC_MF_BITMAP                     EQUATE(04h)
CFC_MF_OWNERDRAW                  EQUATE(0100h)
CFC_MF_POPUP                      EQUATE(010h)
CFC_MF_MENUBARBREAK               EQUATE(020h)
CFC_MF_MENUBREAK                  EQUATE(040h)
CFC_MF_UNHILITE                   EQUATE(0)
CFC_MF_HILITE                     EQUATE(080h)
CFC_MF_DEFAULT                    EQUATE(01000h)
CFC_MF_SYSMENU                    EQUATE(02000h)
CFC_MF_HELP                       EQUATE(04000h)
CFC_MF_RIGHTJUSTIFY               EQUATE(04000h)
CFC_MF_MOUSESELECT                EQUATE(08000h)

CFC_MFT_STRING                    EQUATE(CFC_MF_STRING)
CFC_MFT_BITMAP                    EQUATE(CFC_MF_BITMAP)
CFC_MFT_MENUBARBREAK              EQUATE(CFC_MF_MENUBARBREAK)
CFC_MFT_MENUBREAK                 EQUATE(CFC_MF_MENUBREAK)
CFC_MFT_OWNERDRAW                 EQUATE(CFC_MF_OWNERDRAW)
CFC_MFT_RADIOCHECK                EQUATE(0200h)
CFC_MFT_SEPARATOR                 EQUATE(CFC_MF_SEPARATOR)
CFC_MFT_RIGHTORDER                EQUATE(02000h)
CFC_MFT_RIGHTJUSTIFY              EQUATE(CFC_MF_RIGHTJUSTIFY)

CFC_MIM_MAXHEIGHT                 EQUATE(1)
CFC_MIM_BACKGROUND                EQUATE(2)
CFC_MIM_HELPID                    EQUATE(4)
CFC_MIM_MENUDATA                  EQUATE(8)
CFC_MIM_STYLE                     EQUATE(16)
CFC_MIM_APPLYTOSUBMENUS           EQUATE(080000000h)

CFC_MIIM_STATE                    EQUATE(01h)
CFC_MIIM_ID                       EQUATE(02h)
CFC_MIIM_SUBMENU                  EQUATE(04h)
CFC_MIIM_CHECKMARKS               EQUATE(08h)
CFC_MIIM_TYPE                     EQUATE(010h)
CFC_MIIM_DATA                     EQUATE(020h)
CFC_MIIM_STRING                   EQUATE(64)
CFC_MIIM_BITMAP                   EQUATE(128)
CFC_MIIM_FTYPE                    EQUATE(256)


CFC_MFS_GRAYED                    EQUATE(03h)
CFC_MFS_DISABLED                  EQUATE(CFC_MFS_GRAYED)
CFC_MFS_CHECKED                   EQUATE(CFC_MF_CHECKED)
CFC_MFS_HILITE                    EQUATE(CFC_MF_HILITE)
CFC_MFS_ENABLED                   EQUATE(CFC_MF_ENABLED)
CFC_MFS_UNCHECKED                 EQUATE(CFC_MF_UNCHECKED)
CFC_MFS_UNHILITE                  EQUATE(CFC_MF_UNHILITE)
CFC_MFS_DEFAULT                   EQUATE(CFC_MF_DEFAULT)


CFC_ICC_LISTVIEW_CLASSES          EQUATE(01h) ! listview, header
CFC_ICC_TREEVIEW_CLASSES          EQUATE(02h) ! treeview, tooltips
CFC_ICC_BAR_CLASSES               EQUATE(04h) ! toolbar, statusbar, trackbar, tooltips
CFC_ICC_TAB_CLASSES               EQUATE(08h) ! tab, tooltips
CFC_ICC_UPDOWN_CLASS              EQUATE(010h) ! updown
CFC_ICC_PROGRESS_CLASS            EQUATE(020h) ! progress
CFC_ICC_HOTKEY_CLASS              EQUATE(040h) ! hotkey
CFC_ICC_ANIMATE_CLASS             EQUATE(080h) ! animate
CFC_ICC_WIN95_CLASSES             EQUATE(0FFh)
CFC_ICC_DATE_CLASSES              EQUATE(0100h) ! month picker, date picker, time picker, updown
CFC_ICC_USEREX_CLASSES            EQUATE(0200h) ! comboex
CFC_ICC_COOL_CLASSES              EQUATE(0400h) ! rebar (coolbar) control
CFC_ICC_INTERNET_CLASSES          EQUATE(0800h)
CFC_ICC_PAGESCROLLER_CLASS        EQUATE(01000h) !  page scroller
CFC_ICC_NATIVEFNTCTL_CLASS        EQUATE(02000h) ! native font control
CFC_ICC_STANDARD_CLASSES          EQUATE(04000h)
CFC_ICC_LINK_CLASS                EQUATE(08000h)


CFC_WS_EX_DLGMODALFRAME           EQUATE(00000001h)
CFC_WS_EX_NOPARENTNOTIFY          EQUATE(00000004h)
CFC_WS_EX_TOPMOST                 EQUATE(00000008h)
CFC_WS_EX_ACCEPTFILES             EQUATE(00000010h)
CFC_WS_EX_TRANSPARENT             EQUATE(00000020h)
CFC_WS_EX_MDICHILD                EQUATE(00000040h)
CFC_WS_EX_TOOLWINDOW              EQUATE(00000080h)
CFC_WS_EX_WINDOWEDGE              EQUATE(00000100h)
CFC_WS_EX_CLIENTEDGE              EQUATE(00000200h)
CFC_WS_EX_CONTEXTHELP             EQUATE(00000400h)

CFC_WS_EX_RIGHT                   EQUATE(00001000h)
CFC_WS_EX_LEFT                    EQUATE(00000000h)
CFC_WS_EX_RTLREADING              EQUATE(0002000h)
CFC_WS_EX_LTRREADING              EQUATE(00000000h)
CFC_WS_EX_LEFTSCROLLBAR           EQUATE(00004000h)
CFC_WS_EX_RIGHTSCROLLBAR          EQUATE(00000000h)

CFC_WS_EX_CONTROLPARENT           EQUATE(00010000h)
CFC_WS_EX_STATICEDGE              EQUATE(00020000h)
CFC_WS_EX_APPWINDOW               EQUATE(00040000h)

CFC_WS_EX_OVERLAPPEDWINDOW        EQUATE(CFC_WS_EX_WINDOWEDGE + CFC_WS_EX_CLIENTEDGE)
CFC_WS_EX_PALETTEWINDOW           EQUATE(CFC_WS_EX_WINDOWEDGE + CFC_WS_EX_TOOLWINDOW + CFC_WS_EX_TOPMOST)

CFC_WS_EX_LAYERED                 EQUATE(00080000h)

CFC_WS_EX_NOINHERITLAYOUT         EQUATE(00100000h) ! Disable inheritence of mirroring by children
CFC_WS_EX_LAYOUTRTL               EQUATE(00400000h) ! Right to left mirroring

CFC_WS_EX_COMPOSITED              EQUATE(02000000h)
CFC_WS_EX_NOACTIVATE              EQUATE(08000000h)

! rebar control
CFC_RBIM_IMAGELIST                EQUATE(00000001h)

CFC_RBS_TOOLTIPS                  EQUATE(0100h)
CFC_RBS_VARHEIGHT                 EQUATE(0200h)
CFC_RBS_BANDBORDERS               EQUATE(0400h)
CFC_RBS_FIXEDORDER                EQUATE(0800h)
CFC_RBS_REGISTERDROP              EQUATE(1000h)
CFC_RBS_AUTOSIZE                  EQUATE(2000h)
CFC_RBS_VERTICALGRIPPER           EQUATE(4000h)  ! this always has the vertical gripper (default for horizontal mode)
CFC_RBS_DBLCLKTOGGLE              EQUATE(8000h)

CFC_RBBS_BREAK                    EQUATE(00000001h)  ! break to new line
CFC_RBBS_FIXEDSIZE                EQUATE(00000002h)  ! band can't be sized
CFC_RBBS_CHILDEDGE                EQUATE(00000004h)  ! edge around top & bottom of child window
CFC_RBBS_HIDDEN                   EQUATE(00000008h)  ! don't show
CFC_RBBS_NOVERT                   EQUATE(00000010h)  ! don't show when vertical
CFC_RBBS_FIXEDBMP                 EQUATE(00000020h)  ! bitmap doesn't move during band resize

CFC_RBBS_VARIABLEHEIGHT           EQUATE(00000040h)  ! allow autosizing of this child vertically
CFC_RBBS_GRIPPERALWAYS            EQUATE(00000080h)  ! always show the gripper
CFC_RBBS_NOGRIPPER                EQUATE(00000100h)  ! never show the gripper
CFC_RBBS_USECHEVRON               EQUATE(00000200h)  ! display drop-down button for this band if it's sized smaller than ideal width
CFC_RBBS_HIDETITLE                EQUATE(00000400h)  ! keep band title hidden
CFC_RBBS_TOPALIGN                 EQUATE(00000800h)  ! keep band title hidden

CFC_RBBIM_STYLE                   EQUATE(00000001h)
CFC_RBBIM_COLORS                  EQUATE(00000002h)
CFC_RBBIM_TEXT                    EQUATE(00000004h)
CFC_RBBIM_IMAGE                   EQUATE(00000008h)
CFC_RBBIM_CHILD                   EQUATE(00000010h)
CFC_RBBIM_CHILDSIZE               EQUATE(00000020h)
CFC_RBBIM_SIZE                    EQUATE(00000040h)
CFC_RBBIM_BACKGROUND              EQUATE(00000080h)
CFC_RBBIM_ID                      EQUATE(00000100h)
CFC_RBBIM_IDEALSIZE               EQUATE(00000200h)
CFC_RBBIM_LPARAM                  EQUATE(00000400h)
CFC_RBBIM_HEADERSIZE              EQUATE(00000800h)  ! control the size of the header


CFC_CCS_TOP                       EQUATE(00000001h)
CFC_CCS_NOMOVEY                   EQUATE(00000002h)
CFC_CCS_BOTTOM                    EQUATE(00000003h)
CFC_CCS_NORESIZE                  EQUATE(00000004h)
CFC_CCS_NOPARENTALIGN             EQUATE(00000008h)
CFC_CCS_ADJUSTABLE                EQUATE(00000020h)
CFC_CCS_NODIVIDER                 EQUATE(00000040h)
CFC_CCS_VERT                      EQUATE(00000080h)
CFC_CCS_LEFT                      EQUATE(CFC_CCS_VERT + CFC_CCS_TOP)
CFC_CCS_RIGHT                     EQUATE(CFC_CCS_VERT + CFC_CCS_BOTTOM)
CFC_CCS_NOMOVEX                   EQUATE(CFC_CCS_VERT + CFC_CCS_NOMOVEY)

CFC_WM_USER                       EQUATE(0400h)
CFC_RB_INSERTBANDA                EQUATE(CFC_WM_USER +  1)
CFC_RB_DELETEBAND                 EQUATE(CFC_WM_USER +  2)
CFC_RB_GETBARINFO                 EQUATE(CFC_WM_USER +  3)
CFC_RB_SETBARINFO                 EQUATE(CFC_WM_USER +  4)
CFC_RB_GETBANDINFO                EQUATE(CFC_WM_USER +  5)
CFC_RB_SETBANDINFOA               EQUATE(CFC_WM_USER +  6)
CFC_RB_SETPARENT                  EQUATE(CFC_WM_USER +  7)
CFC_RB_HITTEST                    EQUATE(CFC_WM_USER +  8)
CFC_RB_GETRECT                    EQUATE(CFC_WM_USER +  9)
CFC_RB_INSERTBANDW                EQUATE(CFC_WM_USER +  10)
CFC_RB_SETBANDINFOW               EQUATE(CFC_WM_USER +  11)
CFC_RB_GETBANDCOUNT               EQUATE(CFC_WM_USER +  12)
CFC_RB_GETROWCOUNT                EQUATE(CFC_WM_USER +  13)
CFC_RB_GETROWHEIGHT               EQUATE(CFC_WM_USER +  14)
CFC_RB_IDTOINDEX                  EQUATE(CFC_WM_USER +  16) ! wParam == id
CFC_RB_GETTOOLTIPS                EQUATE(CFC_WM_USER +  17)
CFC_RB_SETTOOLTIPS                EQUATE(CFC_WM_USER +  18)
CFC_RB_SETBKCOLOR                 EQUATE(CFC_WM_USER +  19) ! sets the default BK color
CFC_RB_GETBKCOLOR                 EQUATE(CFC_WM_USER +  20) ! defaults to CLR_NONE
CFC_RB_SETTEXTCOLOR               EQUATE(CFC_WM_USER +  21)
CFC_RB_GETTEXTCOLOR               EQUATE(CFC_WM_USER +  22) ! defaults to 0x00000000

CFC_RB_GETBARHEIGHT               EQUATE(CFC_WM_USER + 27)

CFC_ES_LEFT                       EQUATE(0000h)
CFC_ES_CENTER                     EQUATE(0001h)
CFC_ES_RIGHT                      EQUATE(0002h)
CFC_ES_MULTILINE                  EQUATE(0004h)
CFC_ES_UPPERCASE                  EQUATE(0008h)
CFC_ES_LOWERCASE                  EQUATE(0010h)
CFC_ES_PASSWORD                   EQUATE(0020h)
CFC_ES_AUTOVSCROLL                EQUATE(0040h)
CFC_ES_AUTOHSCROLL                EQUATE(0080h)
CFC_ES_NOHIDESEL                  EQUATE(0100h)
CFC_ES_OEMCONVERT                 EQUATE(0400h)
CFC_ES_READONLY                   EQUATE(0800h)
CFC_ES_WANTRETURN                 EQUATE(01000h)
CFC_ES_NUMBER                     EQUATE(02000h)

CFC_SWP_NOSIZE                    EQUATE(0001h)
CFC_SWP_NOMOVE                    EQUATE(0002h)
CFC_SWP_NOZORDER                  EQUATE(0004h)
CFC_SWP_NOREDRAW                  EQUATE(0008h)
CFC_SWP_NOACTIVATE                EQUATE(0010h)
CFC_SWP_FRAMECHANGED              EQUATE(0020h)  ! The frame changed: send WM_NCCALCSIZE
CFC_SWP_SHOWWINDOW                EQUATE(0040h)
CFC_SWP_HIDEWINDOW                EQUATE(0080h)
CFC_SWP_NOCOPYBITS                EQUATE(0100h)
CFC_SWP_NOOWNERZORDER             EQUATE(0200h)  ! Don't do owner Z ordering
CFC_SWP_NOSENDCHANGING            EQUATE(0400h)  ! Don't send WM_WINDOWPOSCHANGING
CFC_SWP_DRAWFRAME                 EQUATE(CFC_SWP_FRAMECHANGED)
CFC_SWP_NOREPOSITION              EQUATE(CFC_SWP_NOOWNERZORDER)
CFC_SWP_DEFERERASE                EQUATE(2000h)
CFC_SWP_ASYNCWINDOWPOS            EQUATE(04000h)

CFC_WVR_ALIGNTOP                  EQUATE(0010h)
CFC_WVR_ALIGNLEFT                 EQUATE(0020h)
CFC_WVR_ALIGNBOTTOM               EQUATE(0040h)
CFC_WVR_ALIGNRIGHT                EQUATE(0080h)
CFC_WVR_HREDRAW                   EQUATE(0100h)
CFC_WVR_VREDRAW                   EQUATE(0200h)
CFC_WVR_REDRAW                    EQUATE(CFC_WVR_HREDRAW + CFC_WVR_VREDRAW)
CFC_WVR_VALIDRECTS                EQUATE(0400h)

CFC_RBN_HEIGHTCHANGE              EQUATE(4294966465)
CFC_RBN_GETOBJECT                 EQUATE(4294966464)
CFC_RBN_LAYOUTCHANGED             EQUATE(4294966463)
CFC_RBN_AUTOSIZE                  EQUATE(4294966462)
CFC_RBN_BEGINDRAG                 EQUATE(4294966461)
CFC_RBN_ENDDRAG                   EQUATE(4294966460)
CFC_RBN_DELETINGBAND              EQUATE(4294966459)
CFC_RBN_DELETEDBAND               EQUATE(4294966458)
CFC_RBN_CHILDSIZE                 EQUATE(4294966457)

! toolbar control
CFC_TBSTATE_CHECKED               EQUATE(001h)
CFC_TBSTATE_PRESSED               EQUATE(002h)
CFC_TBSTATE_ENABLED               EQUATE(004h)
CFC_TBSTATE_HIDDEN                EQUATE(008h)
CFC_TBSTATE_INDETERMINATE         EQUATE(010h)
CFC_TBSTATE_WRAP                  EQUATE(020h)
CFC_TBSTATE_ELLIPSES              EQUATE(040h)
CFC_TBSTATE_MARKED                EQUATE(080h)

CFC_TBSTYLE_BUTTON                EQUATE(0000h)
CFC_TBSTYLE_SEP                   EQUATE(0001h)
CFC_TBSTYLE_CHECK                 EQUATE(0002h)
CFC_TBSTYLE_GROUP                 EQUATE(0004h)
CFC_TBSTYLE_CHECKGROUP            EQUATE(CFC_TBSTYLE_GROUP + CFC_TBSTYLE_CHECK)
CFC_TBSTYLE_DROPDOWN              EQUATE(0008h)
CFC_TBSTYLE_AUTOSIZE              EQUATE(0010h) ! automatically calculate the cx of the button
CFC_TBSTYLE_NOPREFIX              EQUATE(0020h) ! if this button should not have accel prefix
CFC_BTNS_WHOLEDROPDOWN            EQUATE(00080h)

CFC_TBSTYLE_TOOLTIPS              EQUATE(0100h)
CFC_TBSTYLE_WRAPABLE              EQUATE(0200h)
CFC_TBSTYLE_ALTDRAG               EQUATE(0400h)
CFC_TBSTYLE_FLAT                  EQUATE(0800h)
CFC_TBSTYLE_LIST                  EQUATE(01000h)
CFC_TBSTYLE_CUSTOMERASE           EQUATE(02000h)
CFC_TBSTYLE_REGISTERDROP          EQUATE(04000h)
CFC_TBSTYLE_TRANSPARENT           EQUATE(08000h)
CFC_TBSTYLE_EX_DRAWDDARROWS       EQUATE(001h)
CFC_TBSTYLE_EX_HIDECLIPPEDBUTTONS EQUATE(010h)

CFC_TBR_ON_REBAR_STYLE            EQUATE(CFC_TBSTYLE_TRANSPARENT + CFC_TBSTYLE_FLAT + CFC_CCS_NOPARENTALIGN + CFC_CCS_NORESIZE + CFC_CCS_NODIVIDER)
CFC_TBR_ON_WND_STYLE              EQUATE(CFC_TBSTYLE_TRANSPARENT + CFC_TBSTYLE_FLAT)


CFC_TB_ENABLEBUTTON               EQUATE(CFC_WM_USER + 1)
CFC_TB_CHECKBUTTON                EQUATE(CFC_WM_USER + 2)
CFC_TB_PRESSBUTTON                EQUATE(CFC_WM_USER + 3)
CFC_TB_HIDEBUTTON                 EQUATE(CFC_WM_USER + 4)
CFC_TB_INDETERMINATE              EQUATE(CFC_WM_USER + 5)
CFC_TB_MARKBUTTON                 EQUATE(CFC_WM_USER + 6)
CFC_TB_ISBUTTONENABLED            EQUATE(CFC_WM_USER + 9)
CFC_TB_ISBUTTONCHECKED            EQUATE(CFC_WM_USER + 10)
CFC_TB_ISBUTTONPRESSED            EQUATE(CFC_WM_USER + 11)
CFC_TB_ISBUTTONHIDDEN             EQUATE(CFC_WM_USER + 12)
CFC_TB_ISBUTTONINDETERMINATE      EQUATE(CFC_WM_USER + 13)
CFC_TB_ISBUTTONHIGHLIGHTED        EQUATE(CFC_WM_USER + 14)
CFC_TB_SETSTATE                   EQUATE(CFC_WM_USER + 17)
CFC_TB_GETSTATE                   EQUATE(CFC_WM_USER + 18)
CFC_TB_ADDBITMAP                  EQUATE(CFC_WM_USER + 19)
CFC_TB_ADDBUTTONS                 EQUATE(CFC_WM_USER + 20)
CFC_TB_INSERTBUTTON               EQUATE(CFC_WM_USER + 21)
CFC_TB_DELETEBUTTON               EQUATE(CFC_WM_USER + 22)
CFC_TB_GETBUTTON                  EQUATE(CFC_WM_USER + 23)
CFC_TB_BUTTONCOUNT                EQUATE(CFC_WM_USER + 24)
CFC_TB_COMMANDTOINDEX             EQUATE(CFC_WM_USER + 25)
CFC_TB_SAVERESTOREA               EQUATE(CFC_WM_USER + 26)
CFC_TB_SAVERESTOREW               EQUATE(CFC_WM_USER + 76)
CFC_TB_CUSTOMIZE                  EQUATE(CFC_WM_USER + 27)
CFC_TB_ADDSTRINGA                 EQUATE(CFC_WM_USER + 28)
CFC_TB_ADDSTRINGW                 EQUATE(CFC_WM_USER + 77)
CFC_TB_GETITEMRECT                EQUATE(CFC_WM_USER + 29)
CFC_TB_BUTTONSTRUCTSIZE           EQUATE(CFC_WM_USER + 30)
CFC_TB_SETBUTTONSIZE              EQUATE(CFC_WM_USER + 31)
CFC_TB_SETBITMAPSIZE              EQUATE(CFC_WM_USER + 32)
CFC_TB_AUTOSIZE                   EQUATE(CFC_WM_USER + 33)
CFC_TB_GETTOOLTIPS                EQUATE(CFC_WM_USER + 35)
CFC_TB_SETTOOLTIPS                EQUATE(CFC_WM_USER + 36)
CFC_TB_SETPARENT                  EQUATE(CFC_WM_USER + 37)
CFC_TB_SETROWS                    EQUATE(CFC_WM_USER + 39)
CFC_TB_GETROWS                    EQUATE(CFC_WM_USER + 40)
CFC_TB_SETCMDID                   EQUATE(CFC_WM_USER + 42)
CFC_TB_CHANGEBITMAP               EQUATE(CFC_WM_USER + 43)
CFC_TB_GETBITMAP                  EQUATE(CFC_WM_USER + 44)
CFC_TB_GETBUTTONTEXTA             EQUATE(CFC_WM_USER + 45)
CFC_TB_GETBUTTONTEXTW             EQUATE(CFC_WM_USER + 75)
CFC_TB_REPLACEBITMAP              EQUATE(CFC_WM_USER + 46)
CFC_TB_SETINDENT                  EQUATE(CFC_WM_USER + 47)
CFC_TB_SETIMAGELIST               EQUATE(CFC_WM_USER + 48)
CFC_TB_GETIMAGELIST               EQUATE(CFC_WM_USER + 49)
CFC_TB_LOADIMAGES                 EQUATE(CFC_WM_USER + 50)
CFC_TB_GETRECT                    EQUATE(CFC_WM_USER + 51)
CFC_TB_SETHOTIMAGELIST            EQUATE(CFC_WM_USER + 52)
CFC_TB_GETHOTIMAGELIST            EQUATE(CFC_WM_USER + 53)
CFC_TB_SETDISABLEDIMAGELIST       EQUATE(CFC_WM_USER + 54)
CFC_TB_GETDISABLEDIMAGELIST       EQUATE(CFC_WM_USER + 55)
CFC_TB_SETSTYLE                   EQUATE(CFC_WM_USER + 56)
CFC_TB_GETSTYLE                   EQUATE(CFC_WM_USER + 57)
CFC_TB_GETBUTTONSIZE              EQUATE(CFC_WM_USER + 58)
CFC_TB_SETBUTTONWIDTH             EQUATE(CFC_WM_USER + 59)
CFC_TB_SETMAXTEXTROWS             EQUATE(CFC_WM_USER + 60)
CFC_TB_GETTEXTROWS                EQUATE(CFC_WM_USER + 61)
CFC_TB_GETOBJECT                  EQUATE(CFC_WM_USER + 62)
CFC_TB_GETBUTTONINFO              EQUATE(CFC_WM_USER + 65)
CFC_TB_SETBUTTONINFO              EQUATE(CFC_WM_USER + 66)
CFC_TB_HITTEST                    EQUATE(CFC_WM_USER + 69)
CFC_TB_SETDRAWTEXTFLAGS           EQUATE(CFC_WM_USER + 70)
CFC_TB_GETHOTITEM                 EQUATE(CFC_WM_USER + 71)
CFC_TB_SETHOTITEM                 EQUATE(CFC_WM_USER + 72)
CFC_TB_SETANCHORHIGHLIGHT         EQUATE(CFC_WM_USER + 73)
CFC_TB_GETANCHORHIGHLIGHT         EQUATE(CFC_WM_USER + 74)

CFC_TB_GETINSERTMARK              EQUATE(CFC_WM_USER + 79)
CFC_TB_SETINSERTMARK              EQUATE(CFC_WM_USER + 80)
CFC_TB_INSERTMARKHITTEST          EQUATE(CFC_WM_USER + 81)
CFC_TB_MOVEBUTTON                 EQUATE(CFC_WM_USER + 82)
CFC_TB_GETMAXSIZE                 EQUATE(CFC_WM_USER + 83)
CFC_TB_SETEXTENDEDSTYLE           EQUATE(CFC_WM_USER + 84)
CFC_TB_GETEXTENDEDSTYLE           EQUATE(CFC_WM_USER + 85)
CFC_TB_GETPADDING                 EQUATE(CFC_WM_USER + 86)
CFC_TB_SETPADDING                 EQUATE(CFC_WM_USER + 87)
CFC_TB_SETINSERTMARKCOLOR         EQUATE(CFC_WM_USER + 88)
CFC_TB_GETINSERTMARKCOLOR         EQUATE(CFC_WM_USER + 89)


                                                                                                                                          
                                                                                                                                          
CFC_NM_RELEASEDCAPTURE            EQUATE(4294967280)
                                                                                                                                          
CFC_TBIF_IMAGE                    EQUATE(00000001h)
CFC_TBIF_TEXT                     EQUATE(00000002h)
CFC_TBIF_STATE                    EQUATE(00000004h)
CFC_TBIF_STYLE                    EQUATE(00000008h)
CFC_TBIF_LPARAM                   EQUATE(00000010h)
CFC_TBIF_COMMAND                  EQUATE(00000020h)
CFC_TBIF_SIZE                     EQUATE(00000040h)

CFC_CLR_NONE                      EQUATE(4294967295)
CFC_CLR_DEFAULT                   EQUATE(0FF000000h)

CFC_TB_SETCOLORSCHEME             EQUATE(02002h)
CFC_TB_GETCOLORSCHEME             EQUATE(02003h)

CFC_TTN_GETDISPINFOA              EQUATE(4294966776)
CFC_TTN_GETDISPINFOW              EQUATE(4294966766)
CFC_TTN_SHOW                      EQUATE(4294966775)
CFC_TTN_POP                       EQUATE(4294966774)
CFC_TTN_LINKCLICK                 EQUATE(4294966773)
CFC_TTN_UPDATE                    EQUATE(1294966774) ! my message

CFC_TTS_ALWAYSTIP                 EQUATE(001h)
CFC_TTS_NOPREFIX                  EQUATE(002h)
CFC_TTS_NOANIMATE                 EQUATE(010h)
CFC_TTS_NOFADE                    EQUATE(020h)
CFC_TTS_BALLOON                   EQUATE(040h)
CFC_TTS_CLOSE                     EQUATE(080h)

CFC_STD_TOOLTIP                   EQUATE(CFC_TTS_NOPREFIX + CFC_TTS_ALWAYSTIP)
CFC_BALLOON_TOOLTIP               EQUATE(CFC_TTS_NOPREFIX + CFC_TTS_ALWAYSTIP + CFC_TTS_BALLOON)

CFC_TTF_IDISHWND                  EQUATE(0001h)
CFC_TTF_CENTERTIP                 EQUATE(00002h)
CFC_TTF_RTLREADING                EQUATE(00004h)
CFC_TTF_SUBCLASS                  EQUATE(00010h)
CFC_TTF_TRACK                     EQUATE(00020h)
CFC_TTF_ABSOLUTE                  EQUATE(00080h)
CFC_TTF_TRANSPARENT               EQUATE(00100h)
CFC_TTF_PARSELINKS                EQUATE(01000h)
CFC_TTF_DI_SETITEM                EQUATE(08000h)

CFC_TTM_ACTIVATE                  EQUATE(CFC_WM_USER + 1)
CFC_TTM_SETDELAYTIME              EQUATE(CFC_WM_USER + 3)
CFC_TTM_ADDTOOLA                  EQUATE(CFC_WM_USER + 4)
CFC_TTM_ADDTOOLW                  EQUATE(CFC_WM_USER + 50)
CFC_TTM_DELTOOLA                  EQUATE(CFC_WM_USER + 5)
CFC_TTM_DELTOOLW                  EQUATE(CFC_WM_USER + 51)
CFC_TTM_NEWTOOLRECTA              EQUATE(CFC_WM_USER + 6)
CFC_TTM_NEWTOOLRECTW              EQUATE(CFC_WM_USER + 52)
CFC_TTM_RELAYEVENT                EQUATE(CFC_WM_USER + 7)

CFC_TTM_GETTOOLINFOA              EQUATE(CFC_WM_USER + 8)
CFC_TTM_GETTOOLINFOW              EQUATE(CFC_WM_USER + 53)

CFC_TTM_SETTOOLINFOA              EQUATE(CFC_WM_USER + 9)
CFC_TTM_SETTOOLINFOW              EQUATE(CFC_WM_USER + 54)

CFC_TTM_HITTESTA                  EQUATE(CFC_WM_USER +10)
CFC_TTM_HITTESTW                  EQUATE(CFC_WM_USER +55)
CFC_TTM_GETTEXTA                  EQUATE(CFC_WM_USER +11)
CFC_TTM_GETTEXTW                  EQUATE(CFC_WM_USER +56)
CFC_TTM_UPDATETIPTEXTA            EQUATE(CFC_WM_USER +12)
CFC_TTM_UPDATETIPTEXTW            EQUATE(CFC_WM_USER +57)
CFC_TTM_GETTOOLCOUNT              EQUATE(CFC_WM_USER +13)
CFC_TTM_ENUMTOOLSA                EQUATE(CFC_WM_USER +14)
CFC_TTM_ENUMTOOLSW                EQUATE(CFC_WM_USER +58)
CFC_TTM_GETCURRENTTOOLA           EQUATE(CFC_WM_USER + 15)
CFC_TTM_GETCURRENTTOOLW           EQUATE(CFC_WM_USER + 59)
CFC_TTM_WINDOWFROMPOINT           EQUATE(CFC_WM_USER + 16)
CFC_TTM_TRACKACTIVATE             EQUATE(CFC_WM_USER + 17)  ! wParam = TRUE/FALSE start end  lparam = LPTOOLINFO
CFC_TTM_TRACKPOSITION             EQUATE(CFC_WM_USER + 18)  ! lParam = dwPos
CFC_TTM_SETTIPBKCOLOR             EQUATE(CFC_WM_USER + 19)
CFC_TTM_SETTIPTEXTCOLOR           EQUATE(CFC_WM_USER + 20)
CFC_TTM_GETDELAYTIME              EQUATE(CFC_WM_USER + 21)
CFC_TTM_GETTIPBKCOLOR             EQUATE(CFC_WM_USER + 22)
CFC_TTM_GETTIPTEXTCOLOR           EQUATE(CFC_WM_USER + 23)
CFC_TTM_SETMAXTIPWIDTH            EQUATE(CFC_WM_USER + 24)
CFC_TTM_GETMAXTIPWIDTH            EQUATE(CFC_WM_USER + 25)
CFC_TTM_SETMARGIN                 EQUATE(CFC_WM_USER + 26)  ! lParam = lprc
CFC_TTM_GETMARGIN                 EQUATE(CFC_WM_USER + 27)  ! lParam = lprc
CFC_TTM_POP                       EQUATE(CFC_WM_USER + 28)
CFC_TTM_UPDATE                    EQUATE(CFC_WM_USER + 29)
CFC_TTM_GETBUBBLESIZE             EQUATE(CFC_WM_USER + 30)
CFC_TTM_ADJUSTRECT                EQUATE(CFC_WM_USER + 31)
CFC_TTM_SETTITLEA                 EQUATE(CFC_WM_USER + 32)  ! wParam = TTI_*, lParam = char* szTitle
CFC_TTM_SETTITLEW                 EQUATE(CFC_WM_USER + 33)  ! wParam = TTI_*, lParam = wchar* szTitle
CFC_TTM_POPUP                     EQUATE(CFC_WM_USER + 34)
CFC_TTM_GETTITLE                  EQUATE(CFC_WM_USER + 35)  ! wParam = 0, lParam = TTGETTITLE*
CFC_TTM_SETWINDOWTHEME            EQUATE(0200Bh)

CFC_TTDT_AUTOMATIC                EQUATE(0)
CFC_TTDT_RESHOW                   EQUATE(1)
CFC_TTDT_AUTOPOP                  EQUATE(2)
CFC_TTDT_INITIAL                  EQUATE(3)

CFC_WH_CALLWNDPROC                EQUATE(4)
CFC_HC_ACTION                     EQUATE(0)


CFC_HBMMENU_CALLBACK              EQUATE(4294967295)
CFC_HBMMENU_SYSTEM                EQUATE(1)
CFC_HBMMENU_MBAR_RESTORE          EQUATE(2)
CFC_HBMMENU_MBAR_MINIMIZE         EQUATE(3)
CFC_HBMMENU_MBAR_CLOSE            EQUATE(5)
CFC_HBMMENU_MBAR_CLOSE_D          EQUATE(6)
CFC_HBMMENU_MBAR_MINIMIZE_D       EQUATE(7)
CFC_HBMMENU_POPUP_CLOSE           EQUATE(8)
CFC_HBMMENU_POPUP_RESTORE         EQUATE(9)
CFC_HBMMENU_POPUP_MAXIMIZE        EQUATE(10)
CFC_HBMMENU_POPUP_MINIMIZE        EQUATE(11)

CFC_ODT_MENU                      EQUATE(1)
CFC_ODT_LISTBOX                   EQUATE(2)
CFC_ODT_COMBOBOX                  EQUATE(3)
CFC_ODT_BUTTON                    EQUATE(4)
CFC_ODT_STATIC                    EQUATE(5)

CFC_GRADIENT_FILL_RECT_H          EQUATE(0)
CFC_GRADIENT_FILL_RECT_V          EQUATE(1)
CFC_GRADIENT_FILL_TRIANGLE        EQUATE(2)
CFC_GRADIENT_FILL_OP_FLAG         EQUATE(0ffh)


CFC_ODA_DRAWENTIRE                EQUATE(1)
CFC_ODA_SELECT                    EQUATE(2)
CFC_ODA_FOCUS                     EQUATE(4)

CFC_MDITILE_VERTICAL              EQUATE(0)
CFC_MDITILE_HORIZONTAL            EQUATE(1)
CFC_MDITILE_SKIPDISABLED          EQUATE(2)
CFC_MDITILE_ZORDER                EQUATE(4)

CFC_TBN_GETBUTTONINFOA            EQUATE(4294966596)
CFC_TBN_BEGINDRAG                 EQUATE(4294966595)
CFC_TBN_ENDDRAG                   EQUATE(4294966594)
CFC_TBN_BEGINADJUST               EQUATE(4294966593)
CFC_TBN_ENDADJUST                 EQUATE(4294966592)
CFC_TBN_RESET                     EQUATE(4294966591)
CFC_TBN_QUERYINSERT               EQUATE(4294966590)
CFC_TBN_QUERYDELETE               EQUATE(4294966589)
CFC_TBN_TOOLBARCHANGE             EQUATE(4294966588)
CFC_TBN_CUSTHELP                  EQUATE(4294966587)
CFC_TBN_DROPDOWN                  EQUATE(4294966586)
CFC_TBN_GETOBJECT                 EQUATE(4294966584)
CFC_TBN_HOTITEMCHANGE             EQUATE(4294966583)
CFC_TBN_DRAGOUT                   EQUATE(4294966584)
CFC_TBN_DELETINGBUTTON            EQUATE(4294966581)
CFC_TBN_GETDISPINFOA              EQUATE(4294966580)
CFC_TBN_GETDISPINFOW              EQUATE(4294966579)
CFC_TBN_GETINFOTIPA               EQUATE(4294966578)
CFC_TBN_GETINFOTIPW               EQUATE(4294966577)
CFC_TBN_GETBUTTONINFOW            EQUATE(4294966576)
CFC_TBN_RESTORE                   EQUATE(4294966575)
CFC_TBN_SAVE                      EQUATE(4294966574)
CFC_TBN_INITCUSTOMIZE             EQUATE(4294966573)
CFC_TBNRF_HIDEHELP                EQUATE(1)
CFC_TBNRF_ENDCUSTOMIZE            EQUATE(2)


CFC_CDDS_PREPAINT                 EQUATE(1)
CFC_CDDS_POSTPAINT                EQUATE(2)
CFC_CDDS_PREERASE                 EQUATE(3)
CFC_CDDS_POSTERASE                EQUATE(4)
CFC_CDDS_ITEM                     EQUATE(010000h)
CFC_CDDS_ITEMPREPAINT             EQUATE(010001h) ! (CDDS_ITEM | CDDS_PREPAINT)
CFC_CDDS_ITEMPOSTPAINT            EQUATE(010002h) ! (CDDS_ITEM | CDDS_POSTPAINT)
CFC_CDDS_ITEMPREERASE             EQUATE(010003h) ! (CDDS_ITEM | CDDS_PREERASE)
CFC_CDDS_ITEMPOSTERASE            EQUATE(010004h) ! (CDDS_ITEM | CDDS_POSTERASE)
CFC_CDDS_SUBITEM                  EQUATE(020000h)

CFC_CDIS_SELECTED                 EQUATE(0001h)
CFC_CDIS_GRAYED                   EQUATE(0002h)
CFC_CDIS_DISABLED                 EQUATE(0004h)
CFC_CDIS_CHECKED                  EQUATE(0008h)
CFC_CDIS_FOCUS                    EQUATE(0010h)
CFC_CDIS_DEFAULT                  EQUATE(0020h)
CFC_CDIS_HOT                      EQUATE(0040h)
CFC_CDIS_MARKED                   EQUATE(0080h)
CFC_CDIS_INDETERMINATE            EQUATE(0100h)
CFC_CDIS_SHOWKEYBOARDCUES         EQUATE(0200h)

CFC_CDRF_DODEFAULT                EQUATE(0)
CFC_CDRF_NEWFONT                  EQUATE(002h)
CFC_CDRF_SKIPDEFAULT              EQUATE(004h)
CFC_CDRF_NOTIFYPOSTPAINT          EQUATE(010h)
CFC_CDRF_NOTIFYITEMDRAW           EQUATE(020h)
CFC_CDRF_NOTIFYSUBITEMDRAW        EQUATE(020h)
CFC_CDRF_NOTIFYPOSTERASE          EQUATE(040h)

CFC_NIM_ADD                       EQUATE(0)
CFC_NIM_MODIFY                    EQUATE(1)
CFC_NIM_DELETE                    EQUATE(2)
CFC_NIM_SETFOCUS                  EQUATE(3)
CFC_NIM_SETVERSION                EQUATE(4)

CFC_NIF_MESSAGE                   EQUATE(00000001h)
CFC_NIF_ICON                      EQUATE(00000002h)
CFC_NIF_TIP                       EQUATE(00000004h)
CFC_NIF_STATE                     EQUATE(00000008h)
CFC_NIF_INFO                      EQUATE(00000010h)
CFC_NIF_GUID                      EQUATE(00000020h)
CFC_NIF_REALTIME                  EQUATE(00000040h)
CFC_NIF_SHOWTIP                   EQUATE(00000080h)

CFC_NIS_HIDDEN                    EQUATE(1)
CFC_NIS_SHAREDICON                EQUATE(2)

CFC_NIIF_NONE                     EQUATE(00000000h)
CFC_NIIF_INFO                     EQUATE(00000001h)
CFC_NIIF_WARNING                  EQUATE(00000002h)
CFC_NIIF_ERROR                    EQUATE(00000003h)
CFC_NIIF_USER                     EQUATE(00000004h)
CFC_NIIF_NOSOUND                  EQUATE(00000010h)
CFC_NIIF_LARGE_ICON               EQUATE(00000020h)
CFC_NIIF_RESPECT_QUIET_TIME       EQUATE(00000080h)
CFC_NIIF_ICON_MASK                EQUATE(0000000Fh)

CFC_PROCESS_TERMINATE             EQUATE(01h)
CFC_PROCESS_CREATE_THREAD         EQUATE(02h)
CFC_PROCESS_VM_OPERATION          EQUATE(08h)
CFC_PROCESS_VM_READ               EQUATE(010h)
CFC_PROCESS_VM_WRITE              EQUATE(020h)
CFC_PROCESS_DUP_HANDLE            EQUATE(040h)
CFC_PROCESS_CREATE_PROCESS        EQUATE(080h)
CFC_PROCESS_SET_QUOTA             EQUATE(0100h)
CFC_PROCESS_SET_INFORMATION       EQUATE(0200h)
CFC_PROCESS_QUERY_INFORMATION     EQUATE(0400h)

CFC_CREATE_NEW_PROCESS_GROUP      EQUATE(0200h)
CFC_NORMAL_PRIORITY_CLASS         EQUATE(020h)
CFC_STARTF_USESHOWWINDOW          EQUATE(1)


CFC_PAGE_READWRITE                EQUATE(04h)


CFC_SECTION_QUERY                 EQUATE(01)
CFC_SECTION_MAP_WRITE             EQUATE(02h)
CFC_SECTION_MAP_READ              EQUATE(04h)
CFC_SECTION_MAP_EXECUTE           EQUATE(08h)
CFC_SECTION_EXTEND_SIZE           EQUATE(010h)
CFC_SECTION_ALL_ACCESS            EQUATE(CFC_STANDARD_RIGHTS_REQUIRED +  |
                                         CFC_SECTION_QUERY + |
                                         CFC_SECTION_MAP_WRITE + |
                                         CFC_SECTION_MAP_READ + |
                                         CFC_SECTION_MAP_EXECUTE + |
                                         CFC_SECTION_EXTEND_SIZE)
CFC_FILE_MAP_ALL_ACCESS           EQUATE(CFC_SECTION_ALL_ACCESS)
 MAP
    MODULE('WinAPI')
 ! 
 CFC_CallWindowProc(LONG lpPrevWndFunc,ULONG hWnd,ULONG winMsg,ULONG wParam,LONG lParam),LONG,PASCAL,NAME('CallWindowProcA')
 CFC_SetWindowLong(ULONG hWnd,LONG nIndex,LONG dwNewLong),LONG,PASCAL,PROC,NAME('SetWindowLongA')
 CFC_GetProp(ULONG hWnd,*CSTRING lpString),ULONG,RAW,PASCAL,NAME('GetPropA')
 CFC_RemoveProp(ULONG hWnd,*CSTRING lpString),ULONG,PROC,RAW,PASCAL,NAME('RemovePropA')
 CFC_SetProp(ULONG hWnd,*CSTRING lpString,ULONG hData),BOOL,PROC,RAW,PASCAL,NAME('SetPropA')
 CFC_EnumPropsEx(ULONG hWnd,LONG lpEnumFunc,LONG lParam),LONG,PASCAL,RAW,NAME('EnumPropsExA')
 CFC_memcpy(LONG addrTarget,LONG addrSource,LONG inSize),LONG,RAW,NAME('_memcpy'),PROC
 CFC_GetWindowLong(ULONG hWnd,LONG nIndex),LONG,PASCAL,NAME('GetWindowLongA'),PROC
 CFC_MulDiv(LONG nNumber,LONG nNumerator,LONG nDenominator),LONG,PASCAL,NAME('MulDiv')
 CFC_CreateFontIndirect(LONG),ULONG,PASCAL,RAW,NAME('CreateFontIndirectA')
 CFC_GetDeviceCaps(ULONG hdc,LONG inIndex),LONG,PASCAL,NAME('GetDeviceCaps')
 CFC_DeleteObject(LONG hObject),BOOL,RAW,PASCAL,NAME('DeleteObject')
 CFC_SelectObject(LONG hdc,LONG hgdiobj),ULONG,PASCAL,NAME('SelectObject')
 CFC_GetDC(ULONG hWnd),ULONG,PASCAL,NAME('GetDC')
 CFC_TextOut(ULONG hdc,LONG nXStart,LONG nYStart,LONG lpString,LONG cbString),BOOL,PROC,PASCAL,RAW,NAME('TextOutA')
 CFC_SetBkMode(ULONG hdc,LONG BkMode),LONG,PASCAL,PROC,NAME('SetBkMode')
 CFC_CreateCompatibleDC(ULONG hDC),ULONG,PASCAL,NAME('CreateCompatibleDC')
 CFC_DeleteDC(ULONG hdc),BOOL,PASCAL,NAME('DeleteDC')
 CFC_ReleaseDC(ULONG hWnd,ULONG hDC),LONG,PASCAL,PROC,NAME('ReleaseDC')
 CFC_CreateCompatibleBitmap(ULONG hDC,LONG nWidth,LONG nHeight),ULONG,PASCAL,NAME('CreateCompatibleBitmap')
 CFC_BitBlt(ULONG hdcDest,LONG nXDest,LONG nYDest,LONG nWidth,LONG nHeight,ULONG hdcSrc,LONG nXSrc,LONG nYSrc,LONG dwRop),BOOL,PASCAL,NAME('BitBlt')
 CFC_GetSysColorBrush(LONG nIndex),ULONG,PASCAL,NAME('GetSysColorBrush')
 CFC_FillRect(ULONG aDC,LONG lpRect,ULONG aBrush),LONG,RAW,PASCAL,PROC,NAME('FillRect')
 CFC_FrameRect(ULONG aDC,LONG lpRect,ULONG aBrush),LONG,RAW,PASCAL,PROC,NAME('FrameRect')
 CFC_CreateSolidBrush(LONG crColor),ULONG,PASCAL,NAME('CreateSolidBrush')
 CFC_LineTo(ULONG hdc,LONG nXEnd,LONG nYEnd),BOOL,PROC,PASCAL,NAME('LineTo')
 CFC_MoveToEx(ULONG hdc,LONG X,LONG Y,LONG lpPoint = 0),BOOL,PROC,PASCAL,NAME('MoveToEx')
 CFC_DrawText(ULONG hDC,LONG lpString,LONG nCount,LONG lpRect,ULONG uFormat),LONG,RAW,PASCAL,PROC,NAME('DrawTextA')
 CFC_SetCapture(ULONG hWnd),UNSIGNED,PASCAL,PROC,NAME('SetCapture')
 CFC_ReleaseCapture(),BOOL,PASCAL,PROC,NAME('ReleaseCapture')
 CFC_InvalidateRect(ULONG hWnd,LONG lpRect,BOOL bErase),BOOL,PASCAL,RAW,NAME('InvalidateRect'),PROC
 CFC_SetTextAlign(ULONG hdc,ULONG fMode),ULONG,PASCAL,NAME('SetTextAlign')
 CFC_GetTextAlign(ULONG hdc),ULONG,PASCAL,NAME('GetTextAlign')
 CFC_SetMenu(ULONG hWnd,ULONG hMenu),BOOL,PASCAL,NAME('SetMenu')
 CFC_GetMenu(ULONG hWnd),ULONG,PASCAL,NAME('GetMenu')
 CFC_ShowWindow(ULONG hWnd,LONG nCmdShow),BOOL,PASCAL,NAME('ShowWindow')
 CFC_EnumPrinters(LONG Flags,LONG pNamePO,LONG Level,LONG pPrinterEnum,LONG cbBuf,LONG pcbNeeded,LONG pcReturned),BOOL,PASCAL,RAW,NAME('EnumPrintersA')
 CFC_GetLastError(),LONG,RAW,PASCAL,NAME('GetLastError')
 CFC_GetClientRect(ULONG hWnd,LONG lpRect),BOOL,PASCAL,RAW,NAME('GetClientRect'),PROC
 CFC_GetSysColor(LONG nIndex),LONG,PASCAL,NAME('GetSysColor')
 CFC_SetTextColor(ULONG hDC,ULONG crColor),ULONG,RAW,PASCAL,PROC,NAME('SetTextColor')
 CFC_GetCursorPos(LONG lpPoint),BOOL,PASCAl,RAW,NAME('GetCursorPos'),PROC
 CFC_GetWindowRect(LONG hWnd,LONG lpRect),BOOL,PASCAL,RAW,NAME('GetWindowRect'),PROC
 CFC_GetClassName(ULONG hWnd,LONG lpClassName,LONG nMaxCount),LONG,PASCAL,RAW,NAME('GetClassNameA')
 CFC_EnumChildWindows(ULONG hWndParent,LONG lpEnumFunc,LONG lParam),BOOL,PASCAL,NAME('EnumChildWindows')
 CFC_LoadImage(ULONG hInst,LONG lpszIcon,ULONG uType,LONG cxDesired,LONG cyDesired,ULONG fuLoad),ULONG,RAW,PASCAL,NAME('LoadImageA')
 CFC_DrawIconEx(ULONG hDC,LONG xLeft,LONG yTop,LONG hIcon,LONG cxWidth,LONG cyWidth,ULONG iStepIfAniCur,ULONG hbrFlickerFreeDraw,ULONG diFlags),LONG,RAW,PASCAL,PROC,NAME('DrawIconEx')
 CFC_DestroyIcon(ULONG hIcon),BOOL,PASCAL,NAME('DestroyIcon'),PROC
 CFC_GetModuleHandle(ULONG lpModuleName),ULONG,RAW,PASCAL,NAME('GetModuleHandleA')
 CFC_BeginPaint(ULONG hwnd,LONG lpPaint),ULONG,PASCAL,NAME('BeginPaint'),PROC
 CFC_EndPaint(ULONG hWnd,LONG lpPaint),BOOL,PASCAL,NAME('EndPaint'),PROC
 CFC_DrawState(ULONG hdc,ULONG hbr,LONG lpOutputFunc,LONG lData,ULONG wData,LONG x,LONG y,LONG cx,LONG cy,ULONG fuFlags),BOOL,PASCAL,RAW,NAME('DrawStateA')
 CFC_CreateIconIndirect(ULONG pIconInfo),UNSIGNED,RAW,PASCAL,NAME('CreateIconIndirect')
 CFC_GetIconInfo(ULONG hIcon, ULONG pIconInfo),BYTE,RAW,PASCAL,NAME('GetIconInfo')
 CFC_GetPixel(ULONG hDC, LONG nXPos, LONG nYPos),ULONG,RAW,PASCAL,NAME('GetPixel')
 CFC_SetPixel(ULONG hDC, LONG nXPos, LONG nYPos, ULONG crColor),ULONG,RAW,PASCAL,NAME('SetPixel'),PROC
 CFC_GetObject(ULONG hgdiobj, LONG cbBuffer, LONG lpvObject),LONG,RAW,PASCAL,NAME('GetObjectA'),PROC
 CFC_CreateFile(LONG lpFileName,LONG dwDesiredAccess,LONG dwShareMode,LONG lpSecurityAttributes,LONG dwCreationDisposition,LONG dwFlagsAndAttributes,ULONG hTemplateFile),ULONG,PASCAL,RAW,NAME('CreateFileA')
 CFC_ReadFile(ULONG hFile,LONG lpBuffer,LONG nNumberOfBytesToRead,LONG lpNumberOfBytesRead,LONG lpOverlapped),BOOL,PASCAL,RAW,NAME('ReadFile')
 CFC_CloseHandle(ULONG hObject),BOOL,PASCAL,NAME('CloseHandle')
 CFC_SetFilePointer(ULONG hFile,LONG lDistanceToMove,LONG lpDistanceToMoveHigh,LONG dwMoveMethod),LONG,PASCAL,NAME('SetFilePointer')
 CFC_GetSystemMetrics(LONG nIndex),LONG,PASCAL,NAME('GetSystemMetrics')
 CFC_GetScrollInfo(ULONG hwnd,LONG fnBar,LONG lpsi),BOOL,PASCAL,NAME('GetScrollInfo')
 CFC_MoveWindow(ULONG hWnd,LONG X,LONG Y,LONG nWidth,LONG nHeight,BOOL bRepaint),BOOl,PASCAL,NAME('MoveWindow')
 CFC_SetWindowPos(ULONG hWnd,ULONG hWndInsertAfter,LONG X,LONG Y,LONG cx,LONG cy,ULONG uFlags),BOOL,PASCAL,NAME('SetWindowPos')
 CFC_SetParent(ULONG hWndChild,ULONG hWndNewParent),ULONG,PASCAL,NAME('SetParent')
 CFC_GetComputerName(LONG lpBuffer,LONG lpnSize),BOOL,PASCAL,RAW,NAME('GetComputerNameA')
 CFC_GetUserName(LONG lpBuffer,LONG nSize),BOOL,PASCAL,RAW,NAME('GetUserNameA')
 CFC_lstrcpy(*CSTRING inStr,LONG inAddrFrom),LONG,PASCAL,RAW,NAME('lstrcpy'),PROC
 CFC_WriteFile(LONG hFile,LONG lpBuffer,LONG nNumberOfBytesToWrite,LONG lpNumberOfBytesWritten,LONG lpOverlapped),BOOL,PASCAL,RAW,NAME('WriteFile')
 CFC_Sleep(LONG dwMilliseconds),PASCAL,NAME('Sleep')
 CFC_SetTimer(ULONG hWnd,ULONG nIDEvent,ULONG uElapse,LONG lpTimerFunc),ULONG,PASCAL,NAME('SetTimer')
 CFC_KillTimer(ULONG hWnd,ULONG uIDEvent),BOOL,PASCAL,NAME('KillTimer'),PROC
 CFC_CoCreateGuid(LONG pguid),ULONG,PASCAL,RAW,NAME('CoCreateGuid')
 CFC_StringFromGUID2(LONG pguid,LONG polestr,LONG cchMax),LONG,PASCAL,RAW,NAME('StringFromGUID2')
 CFC_WideCharToMultiByte(ULONG CodePage,LONG dwFlags,LONG lpWideCharStr,LONG cchWideChar,LONG lpMultiByteStr,LONG cbMultiByte,LONG lpDefaultChar,BYTE lpUsedDefaultChar),LONG,PASCAL,RAW,NAME('WideCharToMultiByte')
 CFC_LoadLibrary(*CSTRING pszModuleFileName),ULONG,PASCAL,RAW,NAME('LoadLibraryA')
 CFC_FreeLibrary(ULONG hModule),BYTE,PASCAL,RAW,NAME('FreeLibrary'),PROC
 CFC_GetProcAddress(ULONG hModule,*CSTRING pszProcName),LONG,PASCAL,RAW,NAME('GetProcAddress')
 CFC_GetTickCount(),LONG,PASCAL,NAME('GetTickCount')
 CFC_GetVersionEx(LONG lpVersionInfo),BOOL,PASCAL,RAW,NAME('GetVersionExA')
 CFC_RegisterHotKey(ULONG hWnd,LONG id,ULONG fsModifiers,ULONG vk),BOOL,PASCAL,NAME('RegisterHotKey')
 CFC_UnregisterHotKey(ULONG hWnd,LONG id),BOOL,PASCAL,NAME('UnregisterHotKey')
 CFC_GetKeyNameText(LONG lParam,LONG lpString,LONG nSize),LONG,PASCAL,RAW,NAME('GetKeyNameTextA')
 CFC_GetKeyState(LONG nVirtKey),SHORT,PASCAL,NAME('GetKeyState')
 CFC_AllocMem(ULONG BufSize),ULONG,NAME('Cla$NewMemZ')
 CFC_ReAllocMem(ULONG MemAddr,ULONG NewSize),ULONG,NAME('_realloc')
 CFC_FreeMem(ULONG MemAddr),NAME('_free')
 CFC_memmove(LONG addrTarget,LONG addrSource,LONG inSize),LONG,RAW,NAME('_memmove'),PROC
 CFC_ShowCursor(BOOL bShow),LONG,PASCAL,NAME('ShowCursor'),PROC
 CFC_OpenPrinter(LONG pPrinterName,ULONG outhPrinter,LONG pDefault),BOOL,PASCAL,RAW,NAME('OpenPrinterA'),PROC
 CFC_ClosePrinter(ULONG hPrinter),BOOL,PASCAL,RAW,NAME('ClosePrinter'),PROC
 CFC_PrinterProperties(ULONG hWnd,ULONG hPrinter),BOOL,PASCAL,RAW,NAME('PrinterProperties')
 CFC_CreateMenu(),ULONG,PASCAL,RAW,NAME('CreateMenu')
 CFC_AppendMenu(ULONG hMenu,ULONG uFlags,ULONG uIDNewItem,ULONG lpNewItem),BOOL,PASCAL,RAW,NAME('AppendMenuA')
 CFC_SetMenuItemInfo(ULONG hMenu,ULONG uItem,BOOL fByPosition,LONG lpmii),BOOL,PASCAL,RAW,NAME('SetMenuItemInfoA')
 CFC_GetMenuItemInfo(ULONG hMenu,ULONG uItem,BOOL fByPosition,LONG lpmii),BOOL,PASCAL,RAW,NAME('GetMenuItemInfoA')
 CFC_DrawMenuBar(ULONG hWnd),BOOL,PASCAL,RAW,NAME('DrawMenuBar')
 CFC_InsertMenuItem(ULONG hMenu,ULONG uItem,BOOL fByPosition,LONG lpmii),BOOL,PASCAL,RAW,NAME('InsertMenuItemA')
 CFC_GetMenuItemCount(ULONG hMenu),LONG,PASCAL,RAW,NAME('GetMenuItemCount')
 CFC_GetMenuItemID(ULONG hMenu,LONG nPos),ULONG,PASCAL,RAW,NAME('GetMenuItemID')
 CFC_CreatePopupMenu(),ULONG,PASCAL,RAW,NAME('CreatePopupMenu')
 CFC_CreateWindowEx(LONG dwExStyle, | extended window style
                    ULONG lpClassName,  | pointer to registered class name
                    ULONG lpWindowName, | pointer to window name
                    LONG dwStyle,          | window style
                    LONG x,                | horizontal position of window
                    LONG y,                | vertical position of window
                    LONG nWidth,           | window width
                    LONG nHeight,          | window height
                    ULONG hWndParent,      | handle to parent or owner window
                    ULONG hMenu,           | handle to menu, or child-window identifier
                    ULONG hInstance,       | handle to application instance
                    ULONG lpParam),        | pointer to window-creation data
                    ULONG,PASCAL,RAW,NAME('CreateWindowExA')
 CFC_SendMessage(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam),LONG,PASCAL,RAW,NAME('SendMessageA'),PROC
 CFC_PostMessage(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam),LONG,PASCAL,RAW,NAME('PostMessageA'),PROC
 CFC_LoadBitmap(ULONG hInstance,ULONG lpBitmapName),ULONG,PASCAL,RAW,NAME('LoadBitmapA')
 CFC_InitCommonControls(),PASCAL,RAW,NAME('InitCommonControls')
 CFC_EnableWindow(ULONG hWnd,BOOL bEnable),BOOL,PASCAL,RAW,NAME('EnableWindow')
 CFC_MultiByteToWideChar(ULONG CodePage,  | ! code page
                         LONG dwFlags,    | ! character-type options
                         LONG lpMultiByteStr, | ! string to map
                         LONG cbMultiByte,    | ! number of bytes in string
                         LONG lpWideCharStr,  | ! wide-character buffer
                         LONG cchWideChar),   |  size of buffer
                         LONG,PASCAL,RAW,NAME('MultiByteToWideChar')
 CFC_GetACP(),ULONG,PASCAL,RAW,NAME('GetACP')
 CFC_ClientToScreen(ULONG hWnd,LONG lpPoint),BOOL,PASCAL,RAW,NAME('ClientToScreen')
 CFC_SetWindowsHookEx(LONG idHook,ULONG lpfn, LONG hMod, LONG dwThreadId),ULONG,PASCAL,NAME('SetWindowsHookExA')
 CFC_UnhookWindowsHookEx(ULONG hhk),BOOL,PASCAL,PROC,NAME('UnhookWindowsHookEx')
 CFC_CallNextHookEx(ULONG hhk,LONG nCode,ULONG wParam,LONG lParam),LONG,PASCAL,NAME('CallNextHookEx')
 CFC_GetCurrentThreadId(),LONG,PASCAL,NAME('GetCurrentThreadId')
 CFC_ShellExecute(ULONG hwnd,LONG lpOperation,LONG lpFile,LONG lpParameters,LONG lpDirectory,LONG nShowCmd),LONG,PASCAL,RAW,NAME('ShellExecuteA'),PROC
 CFC_ScreenToClient(ULONG hWnd,LONG lpPoint),BOOL,PASCAL,RAW,NAME('ScreenToClient'),PROC
 CFC_SetMenuItemBitmaps(ULONG hMenu,ULONG uPosition,ULONG uFlags,ULONG hBitmapUnchecked,ULONG hBitmapChecked),BOOL,PASCAL,RAW,NAME('SetMenuItemBitmaps'),PROC
 CFC_DestroyMenu(ULONG hMenu),BOOL,PASCAL,RAW,NAME('DestroyMenu'),PROC
 CFC_SetTextCharacterExtra(ULONG hDC,long nCharExtra),LONG,PASCAL,PROC,NAME('SetTextCharacterExtra')
 CFC_GetCurrentObject(ULONG hdc,ULONG uObjectType),ULONG,PASCAL,NAME('GetCurrentObject')
 CFC_GetTextExtentPoint32(ULONG hdc,ULONG,LONG cbString,ULONG),BOOL,PASCAL,PROC,NAME('GetTextExtentPoint32A')
 CFC_ModifyMenu(ULONG hMnu,ULONG uPosition,ULONG uFlags,LONG uIDNewItem,LONG lpNewItem),BOOL,PASCAL,PROC,NAME('ModifyMenuA')
 CFC_SystemParametersInfo(ULONG uiAction,ULONG uiParam,LONG pvParam,ULONG fWinIni),BOOL,RAW,PASCAL,NAME('SystemParametersInfoA'),PROC
 CFC_WindowFromDC(ULONG hDC),ULONG,PASCAL,NAME('WindowFromDC')
 CFC_CreateRectRgn(LONG nLeftRect,LONG nTopRect,LONG nRightRect,LONG nBottomRect),ULONG,PASCAL,NAME('CreateRectRgn')
 CFC_GetDCEx(ULONG hWnd,ULONG hrgnClip,LONG flags),ULONG,PASCAL,NAME('GetDCEx')
 CFC_DeleteMenu(ULONG hMenu,ULONG uPosition,ULONG uFlags),BOOL,PASCAL,NAME('DeleteMenu')
 CFC_TrackPopupMenu(ULONG hMenu,ULONG Flags,LONG x,LONG y,LONG nReserved, ULONG hWnd,ULONG prcRect),BOOL,PASCAL,RAW,NAME('TrackPopupMenu')
 CFC_GetMenuItemRect(ULONG hWnd,ULONG hMenu,ULONG uItem,LONG lprcItem),BOOL,PASCAL,NAME('GetMenuItemRect'),PROC
 CFC_GetWindowDC(ULONG hWnd),ULONG,PASCAL,NAME('GetWindowDC')
 CFC_GetForegroundWindow(),ULONG,PASCAL,RAW,NAME('GetForegroundWindow')
 CFC_GetTopWindow(ULONG hWnd),ULONG,PASCAL,RAW,NAME('GetTopWindow')
 CFC_CascadeWindows(ULONG hwndParent,ULONG wHow,LONG lpRect,ULONG cKids,LONG lpKids),SHORT,PASCAL,RAW,NAME('CascadeWindows')
 CFC_TileWindows(ULONG hwndParent,ULONG wHow,LONG lpRect,ULONG cKids,LONG lpKids),SHORT,PASCAL,RAW,NAME('TileWindows')
 CFC_ArrangeIconicWindows(ULONG hWnd),ULONG,PASCAL,RAW,NAME('ArrangeIconicWindows')
 CFC_GetWindowText(ULONG hWnd,LONG lpString,LONG nMaxCount),LONG,PASCAL,RAW,NAME('GetWindowTextA')
 CFC_SetForegroundWindow(ULONG hWnd),BOOL,PASCAL,RAW,NAME('SetForegroundWindow')
 CFC_SetActiveWindow(ULONG hWnd),ULONG,PASCAL,RAW,NAME('SetActiveWindow')
 CFC_BringWindowToTop(ULONG hWnd),BOOL,PASCAL,NAME('BringWindowToTop')
 CFC_GetFocus(),ULONG,BOOL,PASCAL,NAME('GetFocus')
 CFC_Keybd_Event(BYTE bVk, BYTE bScan, LONG dwFlags, LONG dwExtraInfo),PASCAL,NAME('Keybd_Event')
 CFC_RectInRegion(ULONG hrgn,LONG rect),BOOL,PASCAL,RAW,NAME('RectInRegion')
 CFC_DestroyWindow(ULONG hWnd),BOOL,PASCAL,RAW,NAME('DestroyWindow')
 CFC_Shell_NotifyIcon(LONG dwMessage,LONG lpdata),BOOL,PASCAL,RAW,NAME('Shell_NotifyIconA')
 CFC_RegisterWindowMessage(LONG lpString),ULONG,PASCAL,RAW,NAME('RegisterWindowMessageA')
 CFC_SetFocus(ULONG hWnd),ULONG,PASCAL,RAW,NAME('SetFocus')
 CFC_EnumWindows(LONG lpEnumFunc,ULONG lParam),BOOL,PASCAL,RAW,NAME('EnumWindows')
 CFC_GetWindowThreadProcessId(ULONG,*ULONG),LONG,PASCAL,RAW,NAME('GetWindowThreadProcessId')
 CFC_OpenProcess(ULONG dwDesiredAccess,BOOL bInheritHandle,ULONG dwProcessId),ULONG,PASCAL,RAW,NAME('OpenProcess')
 CFC_TerminateProcess(LONG hProcess,LONG uExitCode),BOOL,PASCAL,RAW,NAME('TerminateProcess')
 CFC_GetExitCodeProcess(LONG hProcess,*LONG lpExitCode),BOOL,PASCAL,PROC,RAW,NAME('GetExitCodeProcess')
 CFC_CreateProcess(*CSTRING lpApplicationName, | pointer to name of executable module
                  *CSTRING lpCommandLine,      | pointer to command line string
                  LONG lpProcessAttributes, | pointer to process security attributes
                  LONG lpThreadAttributes,  | pointer to thread security attributes
                  BOOL bInheritHandles,        | handle inheritance flag
                  LONG dwCreationFlags,       | creation flags
                  LONG lpEnvironment,        | pointer to new environment block
                  *CSTRING lpCurrentDirectory,  | pointer to current directory name
                  *CFC_STARTUPINFO lpStartupInfo, | pointer to STARTUPINFO
                  *CFC_PROCESS_INFORMATION lpProcessInformation), | pointer to PROCESS_INFORMATION
                  BOOL,PASCAL,RAW,NAME('CreateProcessA')
 CFC_SendMessageTimeout(ULONG hWnd,ULONG inMsg,ULONG wParam,LONG lParam,ULONG fuFlags,ULONG uTimeout,LONG lpdwResult),LONG,PASCAL,RAW,NAME('SendMessageTimeoutA'),PROC
 CFC_GetTempPath(LONG nBufferLength,LONG lpBuffer),LONG,PASCAL,RAW,PROC,NAME('GetTempPathA')
 CFC_GetTempFileName(LONG lpPathName,LONG lpPrefixString,ULONG uUnique,LONG lpTempFileName),ULONG,PASCAL,RAW,PROC,NAME('GetTempFileNameA')
 CFC_GetParent(ULONG hWnd),ULONG,PASCAL,RAW,NAME('GetParent')
 CFC_GetMetaFile(LONG lpszMetaFile),ULONG,PASCAL,RAW,NAME('GetMetaFileA')
 CFC_DeleteMetaFile(ULONG  hemf),BOOL,PASCAL,RAW,NAME('DeleteMetaFile')
 CFC_GetFileTime(LONG hFile,LONG lpCreationTime,LONG lpLastAccessTime,LONG lpLastWriteTime),BOOL,PASCAL,RAW,NAME('GetFileTime')
 CFC_FileTimeToSystemTime(LONG lpFileTime,LONG lpSystemTime),BOOL,PASCAL,RAW,NAME('FileTimeToSystemTime')
 CFC_GlobalFree(ULONG hMem),ULONG,PASCAL,RAW,NAME('GlobalFree'),PROC
 CFC_CreateFileMapping(ULONG hFile,LONG lpAttributes,LONG flProtect,LONG dwMaximumSizeHigh,LONG dwMaximumSizeLow,LONG lpName),ULONG,PASCAL,RAW,NAME('CreateFileMappingA')
 CFC_MapViewOfFile(ULONG hFileMappingObject,LONG  dwDesiredAccess,LONG  dwFileOffsetHigh,LONG dwFileOffsetLow,LONG dwNumberOfBytesToMap),LONG,PASCAL,RAW,NAME('MapViewOfFile')
 CFC_UnmapViewOfFile(LONG lpBaseAddress),BOOL,PASCAL,RAW,NAME('UnmapViewOfFile')
 CFC_OpenFileMapping(LONG dwDesiredAccess,BOOL bInheritHandle,LONG lpName),ULONG,PASCAL,RAW,NAME('OpenFileMappingA')
 CFC_GetSaveFileName(LONG lpofn_addr),BOOL,PASCAL,RAW,NAME('GetSaveFileNameA')
    END
 END
_EndOfInclude_


